<?php
// +----------------------------------------------------------------------+
// | PHP version 4                                                        |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: RuruINI.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

require_once dirname(__FILE__)."/Ruru.class.php";


$GLOBALS[Ruru_INI_Values] = array();
$GLOBALS[Ruru_INI_Sections] = array();
$GLOBALS[Ruru_INI_Files] = array();


/**#C
    @Class: RuruINI@$

    @Extends: PEAR Class@$

    @Detail: RuruINI class  INI ̿ϱ  ϴ.
        Ŭ PEAR Library PEAR Class ӹ޽ϴ.
       *.ini  о    ֵ ϴ.
    @$

    @Version: 1.0.1@$

    @History:
        03-09-28 - v1.0.0  : RuruINI Class ۼ
        03-10-04 - v1.0.1  : value() ޼ҵ忡  file   ҷ
    @$

    @Last Modified: 03-09-28@$

    @Author: sunyruru<ruru@unfix.net>@$

    @Use:
        [̸]
        # ¥ ּ
        ;  ּ
        value1 = 1
        value2=2
        value3 = '3'
        ; ǥ ǥ  յ   ʴ´
        value4="  4"
    @$
*/
class RuruINI extends RURU
{
    /**F
        @Name: INIFile@$
        @Type: String@$
        @Version: 1.0.0@$
        @Date: 2003-09-28@$
        @Last Modified: 2003-09-28@$
        @Detail: INI File Name@$
        @Since: 1.0.0@$
        @Access: public@$
    */
    var $INIFile;

    /**MT
    @Name: RuruINI@$
    @Type: void@$
    @Param: String $INIFile Set INI File name@$
    @Version: 1.0.0@$
    @Date: 03-09-28@$
    @Last Modified: 03-09-28@$
    @Detail: RuruINI Constructor Method@$
    @Since: 1.0.0@$
    @Access: public@$
    */
    function RuruINI( $INIFile = '' , $debug = false )
    {
        $this->RURU( $debug );

        if ( $INIFile ) $this->analizeINI( $INIFile );
    }

    /**MT
    @Name: _RuruINI@$
    @Type: void@$
    @Param: void@$
    @Version: 1.0.0@$
    @Date: 03-09-28@$
    @Last Modified: 03-09-28@$
    @Detail: RuruINI Destructor Method@$
    @Since: 1.0.0@$
    @Access: public@$
    */
    function _RuruINI()
    {
        $this->_RURU();

        $GLOBALS["Ruru_INI_Values"] = array();
        $GLOBALS["Ruru_INI_Sections"] = array();
        $GLOBALS["Ruru_INI_Files"] = array();
    }

    /**MT
        @Name: analizeINI@$
        @Type: void@$
        @Param: String $INIFile@$
        @Access: public@$
        @See: Global $Ruru_INI_Values, $Ruru_INI_Sections, $Ruru_INI_Files@$
        @Version: 1.0.0@$
        @Date: 03-09-28@$
        @Last Modified: 03-09-28@$
        @Detail: Analize INI File Variables & Sesctions@$
        @Since: 1.0.0@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    function analizeINI( $INIFile )
    {
        global $Ruru_INI_Values, $Ruru_INI_Sections, $Ruru_INI_Files;

        $section = "";
        $this->INIFile = $INIFile;

        //   ִ Ȯϰ ش  ̹ ε ʾҴ ȮѴ
        if ( file_exists( $INIFile ) && !isset( $Ruru_INI_Files[$INIFile] ) )
        {
            // INI file store
            $Ruru_INI_Files[$INIFile] = $INIFile;

            // INI File load
            $lineData = file($INIFile);

            for ( $i = 0 ; $i < sizeOf( $lineData ); $i++ )
            {
                //   / ƹ͵  ó
                $lineData[$i] = @trim( $lineData[$i] );

                // ereg( "^(;|#)" , $lineData[$i] ) ּ  skip
                if ( !$lineData[$i] || $lineData[$i][0] == ';' || $lineData[$i][0] == '#' ) continue;
                
                // []  section
                elseif ( ereg( "^\[(.*)\]" , $lineData[$i] , $regs ) )
                {
                    $section = strtolower( trim( $regs[1] ) );
                    $Ruru_INI_Sections[$INIFile][] = trim( $regs[1] );
                }
                elseif ( ereg( "^(.*)=(.*)" , $lineData[$i] , $regs ) )
                {
                    $variable = strtolower( trim( $regs[1] ) ); // 
                    $value = trim( $regs[2] ); // 

                    // Quote & Apos process
                    if ( ereg( "^[\"'](.*)[\"']$" , $value , $regs ) )
                        $value = $regs[1];
                    
                    $strLowValue = strtolower( $value );
                    
                    if ( in_array( $strLowValue , array( 'true' , 'yes' , 'on' ) ) ) $value = 1;
                    elseif ( in_array( $strLowValue , array( 'false' , 'no' , 'off' ) ) ) $value = 0;

                    if ( !isset( $Ruru_INI_Values[$INIFile][$section][$variable] ) )
                    {
                        // Ǿ  ʴ 
                        $Ruru_INI_Values[$INIFile][$section][$variable] = $value;
                    }
                    elseif ( gettype( $Ruru_INI_Values[$INIFile][$section][$variable] ) == "array" )
                    {
                        // Ǿ ִµ  迭϶ 迭 ߰
                        $Ruru_INI_Values[$INIFile][$section][$variable][] = $value;
                    }
                    else
                    {
                        // Į󺯼   ߰  迭 ȯѴ
                        $tmp = $Ruru_INI_Values[$INIFile][$section][$variable];
                        $Ruru_INI_Values[$INIFile][$section][$variable] = array( $tmp , $value );
                    }
                }
            }
        }
    } /* End of Function */

    /**MT
        @Name: fileName@$
        @Type: String@$
        @Param: void@$
        @Access: public@$
        @See: $this->INIFile@$
        @Version: 1.0.0@$
        @Date: 03-09-28@$
        @Last Modified: 03-09-28@$
        @Detail: Get INI File name@$
        @Since: 1.0.0@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    function fileName()
    {
        return $this->INIFile;
    } /* End of Function */

    /**MT
        @Name: readSections@$
        @Type: Array@$
        @Param: void@$
        @Access: public@$
        @See: Global $Ruru_INI_Sections@$
        @Version: 1.0.0@$
        @Date: 03-09-28@$
        @Last Modified: 03-09-28@$
        @Detail: Return all Sections@$
        @Since: 1.0.0@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    function readSections()
    {
        global $Ruru_INI_Sections;
        
        //print serialize( $Ruru_INI_Sections );
        return $Ruru_INI_Sections[$this->INIFile];
    } /* End of Function */

    /**MT
        @Name: readSection@$
        @Type: Array( String variable , String value )@$
        @Param: String $section@$
        @Access: public@$
        @See: Global $Ruru_INI_Values@$
        @Version: 1.0.0@$
        @Date: 03-09-28@$
        @Last Modified: 03-09-28@$
        @Detail: Return All variable & value of section@$
        @Since: 1.0.0@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    function readSection( $section )
    {
        global $Ruru_INI_Values;
        return $Ruru_INI_Values[$this->INIFile][strtolower($section)];
    } /* End of Function */

    /**MT
        @Name: value@$
        @Type: Mixed@$
        @Param: String $section@$
        @Param: String $variable@$
        @Param: String $file@$
        @Param: STring $default (default:"")@$
        @Access: public@$
        @See: Global $Ruru_INI_Values@$
        @Version: 1.0.1@$
        @Date: 03-09-28@$
        @Last Modified: 03-10-04@$
        @Detail: return value in variable of section@$
        @Since: 1.0.0@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    function value( $section , $variable , $file = "" , $default = "" )
    {
        global $Ruru_INI_Values;

        if ( $file )
        {
            if ( @$Ruru_INI_Files[$file] != $file )
            {
                $this->analizeINI( $file );
            }
            else
            {
                $this->INIFile = $file;
            }
        }

        $section = strtolower($section);
        $variable = strtolower($variable);

        if ( isset( $Ruru_INI_Values[$this->INIFile][$section][$variable] ) )
        {
            return $Ruru_INI_Values[$this->INIFile][$section][$variable];
        }
        else
        {
            return $default;
        }
    } /* End of Function */
} /* End of Class */


/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>