<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: RuruMySQL.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
chdir( "../pear" );
require_once "PEAR.php";
require_once "DB.php";

require_once dirname(__FILE__)."/RuruError.class.php";
require_once dirname(__FILE__)."/benchmark.class.php";

/**
* RuruMySQL class  MySQL    ׸ ڵȭŰ  ϴ.
*  Ŭ PEAR Library ӹ޽ϴ.
*  Ŭ BenchMark Class մϴ.
* 
* @since    2001
* @version	$Id: RuruMySQL.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*   2003-03-03 - v2.1.37
*   2003-05-13 - v2.1.52 : MYSQL  ɸ ð üũϰ,   .
*   2003-06-06 - v2.1.56 : ߸ BenchmarkǴ  
*   2003-08-11 - v2.1.58 : ߸ include Ǵ  
*   2003-08-11 - v2.1.64 :  庰  ޼ҵ 
*   2003-08-14 - v2.1.69 :  庰  query(array)  ʴ  ذ
*   2003-08-15 - v2.1.73 : _fetch ׿ ٸ    ʴ  (MYSQL::fetch())
*
*   2003-09-12 - v3.0.0  : Base Library PEAR Library ϸ鼭 ü ڵ۾
*   2003-09-28 - v3.0.1  : Error Class PEAR_Error RuruError Class 
*   2003-10-02 - v3.0.11 : smallQuery(), queryResult(), fetch() ޼ҵ  
*   2003-10-03 - v3.0.14 : fetch() ޼ҵ Ƽ  ȯ ù ε ̻    
*   2003-10-03 - v3.0.16 : queryResult(), fetch() ޼ҵ fetch assoc   ʴ  ذ
*   2003-12-12 - v3.1.1  : ڵŸ 
*   2003-12-28 - v3.1.18 : queryResult(), affectedRows() ʿ ڵ  / ӵ ,  
*   2003-12-29 - v3.1.19 : query(), affectedRows(), listTables() Լ ȯǴ ڷ  
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruMySQL extends PEAR
{
    /**
    * MySQL  Benchmark  Object
    *
    * @var	Object	Benchmakr   $Bench    Ŭ ܺο νϽ ü ۷  ̴
    * @access	public
    * @since    03-09-12
    */
    var $Bench;

    /**
    * DB Handler Object
    *
    * @var      object &$DB
    * @access	public
    * @since    03-09-12
    */
    var $DB = null;

    /**
    * MySQL ResultSet ӽ÷  ִ ̴.
    *
    * @var  mixed	$RS
    * @access	public
    * @since    03-09-20
    */
    var $RS = null;

    /**
    * mysql_fetch_array() ̿ؼ ResultSet fetchؿ ͸  ִ 迭 2 迭̴
    *
    * @var  array	$DATA
    * @access	public
    * @since    03-09-20
    */
    var $DATA = array();

    /**
    * mysql_num_rows()   ResultSet īƮ  ̴
    *
    * @var  integer     $DATACNT
    * @access	public
    * @since    03-09-20
    */
    var $DATACNT = 0;

    /**
    * query ߴ  ͷ Ǿ ִ.
    * (ʿ member variance Ŀ   ִ  ̴)
    *
    * @var  int $DATACNT
    * @access	public
    * @since    03-05-13
    */
    var $QUERY = array();

    /**
    *  Ŭ ̿    ִ 
    *
    * @var	integer     $QUERYCNT
    * @access	public
    * @since    03-05-13
    */
    var $QUERYCNT = 0;

    /**
    * Prepare statement identifier array
    *
    * @var      array   $PREPARE
    * @access	public
    * @since    03-05-13
    */
    var $PREPARE = array();

    /**
    * LOCK Flag
    *
    * @var      bool    $LOCK
    * @access	public
    * @since    03-05-13
    */
    var $LOCK = false;


    /**
    * RuruMySQL Constructor Method
    *
    * @param    boolean  $debug
    * @param    array    &$conf  (reference)
    * @param    object  Benchmark   &$Bench      by reference
    * @access	public
    * @see  $Bench, $CONF, DB_conn()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function RuruMySQL( $debug = false , &$DSN , &$Bench )
    {
        $this->PEAR( "RuruError" ); // RURU class constructor 
        $this->_debug = $debug;

        $this->Bench =& $Bench;

        //$this->Bench->startBench( "DBConnection" );

        $this->DB = DB::connect( $DSN );

        //$this->Bench->pauseBench( "DBConnection" );
        //if (DB::isError($this->DB)) exit($this->DB->getMessage());
        if (DB::isError($this->DB)) exit;
    }

    /**
    * RuruMySQL Destructor Method
    *
    * DB_free() method call for free all MySQL Resource.
    *
    * @param    bool    $debug
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function _RuruMySQL()
    {
        $this->_PEAR();
        $this->DB_free();
    }

    /**
    * MySQL  Ǿִ  Ȯϴ ޼ҵ
    *
    * @return   bool
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function isConnect()
    {
        return ( isset( $this->DB ) && is_object( $this->DB ) ) ?
            is_resource( $this->DB->connection ) : false;
    } /* End of Function */

    /**
    * MySQL Util Destructor ȣ ޼ҵ - SQL ҽ Ѵ
    *
    * @access	public
    * @see  isConnect(), mysqlRaiseError(), unLockTables()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function DB_free()
    {
        if ( $this->LOCK )
            $this->unLockTables();

        if ( $this->isConnect() )
            $this->DB->disconnect()
                or $this->mysqlRaiseError();
    }

    /**
    * Query and return fetch data
    *
    * @return   array
    * @param    string      $query
    * @param    boolean     $mode
    * @param    int         $rownum
    * @access	public
    * @see  debug(), query(), fetch()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function queryResult( $query , $mode = false , $rownum = null )
    {
        $this->query( $query );

        if ( $mode || $mode & DB_FETCHMODE_ASSOC )
            $mode = DB_FETCHMODE_ASSOC;
        
        return $this->fetch( $mode , $rownum );
        return ( $this->query( $query ) && $this->DATACNT ) ? $this->fetch() : false;
    }

    /**
    * Query method
    *
    * @param    string    $query
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function query( $query )
    {
        $this->Bench->startBench( "DB" );

        $this->QUERY[] = $query;
        $this->QUERYCNT++;

        $this->RS = $this->DB->query( $query );
        if ( PEAR::isError( $this->RS ) ) { $this->DB->mysqlRaiseError(); exit; }
        $this->affectedRows();

        $this->Bench->pauseBench( "DB" );

        return $this->RS;
    }

    /**
    * Fetch all data from ResultSet resource
    *
    * @param    bool    $mode
    * @param    int     $rownum
    * @return   array
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function fetch( $mode = false , $rownum = 0 )
    {
        $this->Bench->startBench( "DB" );

        if ( !$mode || $mode & DB_FETCHMODE_ASSOC )
            $mode = DB_FETCHMODE_ASSOC;

        if ( $this->DATACNT > 0 )
        {
            $this->DATA = array();
            for ( $i = 0 , $this->DATA = array(); $i < $cnt ; $i++ )
                $this->DATA[] = $this->DB->fetchRow( &$this->RS->result , $mode , $rownum ) or $this->sqlError();

            $this->Bench->pauseBench( "DB" );

            return $this->DATA;
        }
        else
        {
            $this->Bench->pauseBench( "DB" );
            return false;
        }
    }

    /**
    * Prepare Statement
    *
    * @param    string    $RSN      resource name(separator)
    * @param    string    $query    query string
    * @return   array
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function prepare( $RSN , $query )
    {
        $this->Bench->startBench( "DB" );
        $this->PREPARE[$RSN] = $this->DB->prepare( $query )
             or $this->DB->mysqlRaiseError();
        $this->Bench->pauseBench( "DB" );

        return $this->PREPARE[$RSN];
    }

    /**
    * Execute Prepare statement
    *
    * @param    string  $RSN
    * @param    array   &$DATA
    * @return   array
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function execute( $RSN , &$DATA )
    {
        $this->Bench->startBench( "DB" );
        $return = $this->DB->execute( $this->PREPARE[RSN] , &$DATA )
             or $this->DB->mysqlRaiseError();
        $this->Bench->pauseBench( "DB" );

        return ( $return == DB_OK ) ? true : false;
    }

    /**
    * Get rows from ResultSet
    *
    * @access	public
    * @see  $RS, $DATACNT
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function affectedRows()
    {
        if ( !$this->QUERYCNT ) return false; //   

        $this->Bench->startBench( "DB" );
        $this->DATACNT = 0;

        // select  ϸ mysql_num_rows() Լ Ѵ
        if ( eregi( "^select" , trim( $this->QUERY[$this->QUERYCNT-1] ) ) )
            $this->DATACNT = @mysql_num_rows( $this->DB->RS->result );
        else
            $this->DATACNT = @mysql_affected_rows();

        $this->Bench->pauseBench( "DB" );

        return $this->DATACNT;
    }

    /**
    * Ѱ ʵ   ö  
    *
    * @param    string  $query
    * @access	public
    * @see  queryResult(), $DATA
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function smallQuery( $query )
    {
        $this->queryResult( $query );
        return $this->DATA[0][0];
    }

    /**
    * Free ResultSet resource
    *
    * @param    mixed    &$RS
    * @access	public
    * @see  $RS
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function freeResult( &$RS )
    {
        $this->Bench->startBench( "DB" );
        $return = $this->DB->freeResult( $RS )
             or $this->DB->mysqlRaiseError();
        $this->Bench->pauseBench( "DB" );

        return $return;
    }

    /**
    * Lock tables
    *
    * int lockTables( $mode , $tblName[, $tblName[, ...]] )
    *
    * $mode : write or read         Lock mode
    *
    * @return   int
    * @param    boolean     $mode
    * @param    string      $tblName
    * @access	public
    * @see  $LOCK, query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function lockTables( $mode = false )
    {
        $argc = func_num_args();
        $argv = func_get_args();

        if ( !$mode ) $mode = "write";
        if ( $argc == 2 ) $query = "lock tables $argv[1] $mode";
        elseif ( $argv > 2 )
        {
            $query = "lock tables " . $argv[1] . " " . $mode . " , ";
            for ( $i = 2 , $add ="" ; $i < $argc ; $i++ )
            {
                $add .= $argv[$i] . " " . $mode;
                if ( $i != ( $argc - 1 ) ) $add .= " , ";
            }
            $query .= $add;
        }
        else return false;

        $this->LOCK = true;
        return $this->query( $query );
    }

    /**
    * unLockTables()
    *
    * void unLockTables()
    *
    * @access	public
    * @see  query(), $LOCK
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function unLockTables()
    {
        if ( $this->LOCK ) $this->query( "unlock tables" );
        $this->LOCK = false;
    }

    /**
    *  üũϰ ޽ óѴ
    *
    * @param    string    $msg
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    * @throw    RuruMsg
    */
    function sqlError( $errno = 0 ) // $msg = ""
    {
        if ( !$errno && $errno = @mysql_errno() )
        {
            $this->DB->mysqlRaiseError( $errno );
            exit;
        }
        elseif ( $errno && @mysql_errno() )
        {
            $this->DB->mysqlRaiseError( $errno );
            exit;
        }
        else
        {
            return false;
        }
/*
        if ( mysql_error() || mysql_errno() )
        {
            $msg = ( $msg ) ? "(".$msg.")" : "";
            $error = "<b>" . mysql_errno() . "</b> : " . mysql_error() . $msg;
            if ( $this->QUERY[$this->QUERYCNT-1] ) $error .= "<br>Query : " . $this->QUERY[$this->QUERYCNT-1];
            if ( $this->isConnect() ) $this->DB_free();
            // exit( $error ); // ޽ ϸ鼭 Ѵ.

            // ޽ ϸ鼭 Ѵ.
            if ( is_object( $GLOBALS[MSG] ) && method_exists( $GLOBALS[MSG] , 'addError') )
            {
                $MSG =& $GLOBALS[MSG];
                $MSG->addError( $error );
            }
            else
                _destroy( $error );
        }
        */
    } /* End of Function */

    /**
    * Dump Member variable data
    *
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    04-01-09
    */
    function dump()
    {
        echo "LOCK = $this->LOCK<br>\nPREPARE = $this->PREPARE<br>\nQUERYCNT = $this->QUERYCNT<br>\nQUERYCNT = $this->QUERYCNT<br>\nDATACNT = $this->DATACNT<br>\n";
        echo "<br>\nQUERY : <br>\n";
        print_r( $this->QUERY );
        echo "<br>\nDATA : <br>\n";
        print_r( $this->DATA );
    } /* End of Function */
}


/**
* RuruSQLUtil class  MySQL   SQL Լ Util ϴ.
*        Ŭ PEAR Class ӹ޽ϴ.
*        Ŭ BenchMark Class մϴ.
* 
* @since    2003-09-20
* @version	v 1.1.4 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*   03-09-20 - v1.0.0 : RuruSQLUtil Class 
*   03-10-02 - v1.0.8 : getCount() ޼ҵ  
*   03-11-29 - v1.1.0 : ڵ
*   03-12-13 - v1.1.1 : ڵŸ 
*   03-12-17 - v1.1.4 : listTables() tableExist()޼ҵ  
*   04-01-09 - v1.1.5 : ڵ
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruSQLUtil extends PEAR
{
    /**
    * RuruMySQL Object reference ޾Ƽ  member variance
    *
    * @var	object  RuruMySQL  $rSQL
    * @access	public
    * @since    03-09-20
    */
    var $rSQL;


    /**
    * Constructor method
    *
    * @param    object    RuruMySQL     &$RuruMySQL
    * @access	public
    * @see  $rSQL
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function RuruSQLUtil( &$RuruMySQL )
    {
        $this->rSQL =& $RuruMySQL;
        $this->_debug = &$this->rSQL->_debug;
        $this->PEAR( "RuruError" );
    }

    /**
    * Destructor method
    *
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function _RuruMySQLUtil()
    {
        unset( $this->rSQL );
        $this->_PEAR();
    }

    /**
    * Query from sql file
    *
    * @param    string    $sqlFile  sql file path.
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function queryFile( $sqlFile )
    {
        if ( is_file( $sqlFile ) && !is_link( $sqlFile ) && is_readable( $sqlFile ) )
            return $this->rSQL->query( implode( "\n" , @File( $sqlFile ) ) );
        else
            return false;
    }

    /**
    * Get list tables from currunt database
    *
    * @return   array   table list
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function listTables()
    {
        return $this->rSQL->DB->getTables();
    }

    /**
    * Check table exists
    *
    * array tableExist( tblName(array or string) )
    *
    * @return   array
    * @param    string  $tblName
    * @access	public
    * @see      listTables()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function tableExist( $tblName )
    {
        $data = $this->listTables();
        
        if ( is_array( $tblName ) ) // μ 迭϶
        {
            for ( reset( $tblName ), $return = array() ; $var = current( $tblName ) ; next( $tblName ) )
                if ( in_array( $var , $data ) ) $return[] = $var;
            return $return; // sizeOf( $return ) == 0  ̺  ִ ̴
        }
        else
        { // Just One table Check
            return in_array( $tblName , $data );
        }
        return false;
    }

    /**
    * Drop tables
    *
    * bool dropTable( $tbl[, $tbl[, $tbl[, ...]]] )
    *
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function dropTable()
    {
        $argc = func_num_args();
        $argv = func_get_args();

        if ( $argc )
            for ( $i = 1 , $tbl = $argv[0] ; $i < $argc ; $i++ )
                $tbl .= "," . $argv[$i];

        $this->rSQL->query( "drop table $tbl" ) or $this->rSQL->DB->mysqlRaiseError();
        return true;
    }

    /**
    * Get password that use MySQL password() function
    *
    * string getPassword( $password )
    *
    * @return   string
    * @param    string  $password
    * @access	public
    * @see  smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function getPassword( $password )
    {
        return $this->rSQL->smallQuery( "select password('$password')" );
    }

    /**
    * Get tuple count from table
    *
    * int getCount( $tblName )
    *
    * @return   int
    * @param    string    $tblName
    * @access	public
    * @see  smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function getCount( $tblName )
    {
        return $this->rSQL->smallQuery( "select count(*) from ".$tblName );
    }

    /**
    * Optimize tables
    *
    * mixed optimizeTables( $tblName[, $tblName[, ...]] )
    *
    * @return   mixed
    * @param    string    $tblName  Available Multiple tables
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function optimizeTables( $tblName )
    {
        $argc = func_num_args();
        $argv = func_get_args();

        if ( $argc > 0 )
            for ( $i = 0 ; $i < $argc ; $i++ )
                $this->rSQL->query( "optimize table " . $argv[$i] );
    }

    /**
    * Select query
    *
    * array[row][field] selectQuery( $table , $fields = "*" , $options = "" )
    *
    * @return   array   2 迭 ȯȴ
    * @param    string  $table      table name
    * @param    string  $fields     select fields
    * @param    string  $options    select options
    * @access	public
    * @see      queryResult()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function selectQuery( $table , $fields='*' , $options='' )
    {
        return $this->rSQL->queryResult( "select $fields from $table $options" );
    }

    /**
    * Insert Query
    *
    * int insertQuery( $table , $fields , $options )
    *
    * @return   int
    * @param    string  $table      table name
    * @param    string  $fields
    * @param    string  $options
    * @access	public
    * @see      queryResult(), affectedRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function insertQuery( $table , $fields , $options )
    {
        $this->rSQL->queryResult( "insert into $table ($fields) values ($options)" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Update query
    *
    * int updateQuery( $table , $match , $options )
    *
    * @return   int
    * @param    string  $table  table name
    * @param    array   $match  associan array.  key is field, value is value
    * @param    string  $options
    * @access	public
    * @see      addSlash(), queryResult(), affectedRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function updateQuery( $table , $match , $options )
    {
        if ( !is_array( $match ) ) return false;

        $var = '';
        foreach ( $match as $key=>$value ) $var .= "$key='".addSlash( $value )."' ";
        $this->rSQL->queryResult( "update $table set $var where $options" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Delete query
    *
    * int deleteQuery( $table , $options="" )
    *
    * @return   int
    * @param    string  $table  table name
    * @param    string  $options
    * @access	public
    * @see      queryResult(), affecredRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function deleteQuery( $table , $options='' )
    {
        if ( $options ) $where = ' where ';
        $this->rSQL->queryResult( "delete from $table $where $options" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Transform IP Address to Number
    *
    * int   aton( $ip )
    *
    * @return   int     transformed IP Address
    * @param    string  $ip
    * @access	public
    * @see      smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function aton( $ip )
    {
        return $this->rSQL->smallQuery( "select inet_aton('$ip')" );
    }

    /**
    * Transform Number to IP Address
    *
    * string    ntoa( $num )
    *
    * @return   string  IP Address
    * @param    int     $num
    * @access	public
    * @see      smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function ntoa( $num )
    {
        return $this->rSQL->smallQuery( "select inet_ntoa('$num')" );
    }
}// end of class


// Example

echo "<pre>";
$B =& new Benchmark( true );
$DSN = "mysql://sunyruru:sunyruru@localhost/sunyruru";
$SQL =& new RuruMySQL( false , &$DSN , &$B );
echo $SQL->smallQuery( "select password('password')" );
print_r( $this->DATA );
$SQL->dump();
exit;
print_r( $SQL->DB->RS );

//*/


/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>