<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: benchmark.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

require_once dirname(__FILE__)."/Ruru.class.php";

/**
* Automatic Benchmark class
* 
* @since    2001
* @version	$Id: benchmark.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*   2003-04-13 - v1.2.12
*   2003-05-13 - v1.2.25 : ġŷ Pause    κ 
*   2003-06-05 - v1.2.26 :   
*   2003-09-11 - v1.2.35 : RURU Library PEAR Library Base Library 
*   2003-10-04 - v1.3.42 : Error ¹ ذ
*
*   2003-11-30 - v1.4.0  : ڵ
* </pre>
* @copyright	http://ruru.unfix.net
*/
class Benchmark extends RURU
{
    /**
    * Set this class version
    *
    * @var	string	$version
    * @access	public
    */
    var $version = "v1.4.19";

    /**
    * Benchmark Start Time
    *
    * @var	array	$startBench
    * @access	public
    */
    var $startBench = array();

    /**
    * Benchmark End Time
    *
    * @var	array	$startBench
    * @access	public
    */
    var $endBench = array();

    /**
    * Benchmark Result Output Flag
    *
    * @var	array	$outBench
    * @access	public
    * @since    2003-05-13
    */
    var $outBench = array() ;

    /**
    * Benchmark Result Time
    *
    * @var	array	$resultBench
    * @access	public
    * @since    2003-05-13
    */
    var $resultBench = array();

    /**
    * ð  ִ ˷ִ flag
    *
    * @var	array	$pauseBench
    * @access	public
    * @since    2003-09-17
    */
    var $pauseBench = array();

    /**
    * Constructor
    *
    * @param    bool    $debug  Set debug mode
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    */
    function Benchmark( $debug = false )
    {
        $this->RURU( $debug );
    }

    /**
    * Destructor
    *
    * @access	public
    * @see      remainFlush()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    */
    function _Benchmark()
    {
        $this->_RURU();
        $this->remainFlush();
    }

    /**
    * Start time of Benchmark
    *
    * @Param    String  $str    Benchmark thread name variable.(default: "Default")
    * @access	public
    * @see  $startBench, $pauseBench, $resultBench, $outBench, getBench()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    */
    function startBench( $str = "Default" )
    {
        //$this->debug( "Benchmark::startBench( $str )" );
        if ( empty( $str ) ) return false;

        $this->startBench["$str"] = "";

        if ( !$this->startBench[$str] ) // init
        {
            $this->pauseBench[$str] = false;
            $this->resultBench[$str] = 0;
        }

        if ( $this->pauseBench[$str] )
        {
            $this->pauseBench( $str );
            return false;
        }

        $this->startBench[$str] = $this->getBench();
        $this->outBench[$str] = false;
        $this->pauseBench[$str] = true;
    }

    /**
    * Pause Benchmark time
    *
    * @param    string $str Benchmark thread name variable
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    * @see  $startBench, $pauseBench, $resultBench, startBench(), getBench(), resultBench()
    */
    function pauseBench( $str = "Default" )
    {
        //$this->debug( "Benchmark::pauseBench( $str )" );
        // ۵  
        if ( empty( $this->startBench[$str] ) || !$this->pauseBench[$str] )
        {
            $this->startBench( $str );
            return false;
        }

        $tmpTime = $this->getBench(); // Pause Time
        $this->resultBench[$str] += $this->resultBench( $tmpTime , $this->startBench[$str] );
        $this->startBench[$str] = $tmpTime; // Reset Start BenchMark Time
        $this->pauseBench[$str] = false;
    }

    /**
    * End of Benchmark and Print Benchmark
    *
    * @param    string  $str    Benchmark thread name variable
    * @param    integer $out    Output flag
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    * @see  $startBench, $endBench, $resultBench, startBench(), getBench(), resultBench(), printBench()
    */
    function endBench( $str = "Default" , $out = 0 )
    {
        //$this->debug( "Benchmark::endBench( $str , $out )" );
        // ۵  
        if ( empty( $this->startBench[$str] ) ) return false;
        $this->endBench[$str] = $this->getBench();

        $this->resultBench[$str] += $this->resultBench( $this->endBench[$str] , $this->startBench[$str] );

        if ( $out ) $this->printBench( $str );
    }

    /**
    * Get difference of two parameter
    *
    * @return   float   timestamp
    * @param    float   $resultTime1
    * @param    float   $resultTime2
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    */
    function resultBench( $resultTime1 , $resultTime2 )
    {
        //$this->debug( "Benchmark::resultBench( $resultTime1 , $resultTime2 )" );
        return abs( $resultTime1 - $resultTime2 );
    }

    /**
    *  µ  Benchmark Ѵ
    *
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    * @see  $startBench, $outBench, $endBench
    */
    function remainFlush()
    {
        $this->debug( "Benchmark::remainFlush()" );
        $cnt = sizeOf( $this->startBench );
        if ( !$cnt ) return false; // Ѱ  
        $keys = array_keys( $this->startBench );

        //  ִµ  ° ڵ ½Ų
        for ( $i = 0 ; $i < $cnt ; $i++ )
        {
            if ( $this->outBench[$keys[$i]] === false )
                $this->endBench( $keys[$i] , 1 );
        }
    }

    /**
    * Get current unix timestamp
    *
    * @return   float   timestamp
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    */
    function getBench()
    {
        //$this->debug( "Benchmark::getBench()" );
        $Benchmark = explode( " " , microtime() );
        return $Benchmark[0] + $Benchmark[1] ;
    }

    /**
    * ڿ $str  Benchmark thread  Ѵ
    *
    * @param    string  $str
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-17
    * @see  $version, $startBench, $endBench, $resultBench, $outBench
    */
    function printBench( $str = "default" )
    {
        $this->debug( "Benchmark::printBench( $str )" );
        $this->outBench[$str] = true; // Output Check

        echo "<!--\n";
        echo "  ##################################################################\n";
        echo "    ** BenchMark Library(".$this->version.") Excute Time Result **\n";
        echo "  ##################################################################\n";
        echo "    ".$str." Start Benchmark    :   " . $this->startBench[$str] . "\n";
        echo "    ".$str." End Benchmark      :   " . $this->endBench[$str] . "\n";
        echo "  ##################################################################\n";
        echo "    ".$str." Execute Benchmark  :   " . $this->resultBench[$str] . "\n";
        echo "  ##################################################################\n";
        echo "-->\n";
    }
}

/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>