<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: RuruInstall.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

require_once dirname(__FILE__)."/../Ruru.class.php";

/**
* RuruInstall package ⺻  Ѵ
*
* <code><pre>
* RID   : 1 - ,
*                   2 - ġ(, Ų, ... )
*                   3 - ( ID(E-mail, HomePage))
*                   4 -  (ο <br>ױ׸ ̿Ѵ)
*                   5~  - "ɼ: ̵Ұ"  · ۼѴ
*                   (  ü Ư ġ ̵ų  ִ)
* </pre></code>
*
* @since    03-12-15
* @version	$Id: RuruInstall.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RuruInstall
* @History
* <pre>
*   2003-12-15 - v1.0.0  : RuruInstall Class ۼ
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruInstall extends RURU
{
    /**
    * Set this class version
    *
    * @var	string	$version
    * @access	public
    * @since    03-12-15
    */
    var $version = "v1.0.0";

    /**
    * RID  ⺻  
    *
    * @var      string  $openPath
    * @access	public
    * @since    03-12-15
    */
    var $openPath = "";

    /**
    *  ġ ⺻ 
    *
    * @var  	string  $savePath
    * @access	public
    * @since    03-12-15
    */
    var $savePath = "";

    /**
    * Constructor
    *
    * RuruInstall Package debug带 Ѵ
    *
    * @param    bool    $debug
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-12-15
    */
    function RuruInstall( $debug = false )
    {
        $this->RURU( $debug );
    }

    /**
    * Destructor
    *
    * RuruInstall Package  ڿ Ѵ
    *
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-12-15
    */
    function _RuruInstall()
    {
        $this->_RURU();
    }

    /**
    * $openPath Ѵ
    *
    * @param    string  $path
    * @return	bool
    * @access	public
    * @see      $openPath
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-12-15
    */
    function setOpenPath( $path )
    {
        $this->debug( "RuruInstall::setOpenPath( path )" );

        if ( is_dir( $path ) || is_readable( $path ) )
        {
            $this->openPath = $path;
            return true;
        }
        else
        {
            return false;
        }
    } /* End of Function */

    /**
    * $savePath Ѵ
    *
    * @param    string  $path
    * @return	bool
    * @access	public
    * @see      $savePath
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-12-15
    */
    function setSavePath( $path )
    {
        $this->debug( "RuruInstall::setSavePath( path )" );

        if ( is_dir( $path ) || is_writable( $path ) )
        {
            $this->savePath = $path;
            return true;
        }
        else
        {
            return false;
        }
    } /* End of Function */
} /* End of Class */

/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>