<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: Ruru.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

$_destructor_list = array();

if ( !defined( 'RURU_OS' ))
{
    if ( strtolower( substr( PHP_OS , 0 , 3 ) ) == 'win' )
    {
        /**
        * Set OS
        *
        * @const    RURU_OS     Set OS. windows or unix
        */
        define( 'RURU_OS' , 'Windows' );
    }
    else
    {
        /**
        * Set OS
        *
        * @const    RURU_OS     Set OS. windows or unix
        */
        define( 'RURU_OS' , 'Unix' );
    }
}

if ( !defined( "DIR_SEP" ) )
{
    if ( RURU_OS == "Windows" )
    {
        /**
        * Set Seperator
        *
        * @const    DIR_SEP     directory seperator
        */
        define( "DIR_SEP" , "\\" );
    }
    else
    {
        /**
        * Set Seperator
        *
        * @const    DIR_SEP     directory seperator
        */
        define( "DIR_SEP" , "/" );
    }
}

/**
* RURU class  Destructor ϵ ̽  debug / error ó
* ڵ / ȭ ϱ ؼ PEAR Lib.   οϿ ϴ.
* ϴ  RURU class inheritance()鼭 մϴ.
* Ŀ erroró κ ߰ 
* 
* @global   array   $_destructor_list   destructor call object Ʈ Ѵ
* @since    2003-8-11
* @version	$Id: Ruru.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*       03-08-11 - v1.1.39 : get set ޼ҵ ߰
*       03-08-12 - v1.1.40 : _destroy Լ msg  ȵǴ  ذ
*       03-08-15 - v1.1.42 :  ׿ Destructor ϴ  ߰ϴ ޼ҵ(addDesctuctor()) ߰
*       03-11-23 - v1.2.0  :  ϴ Ʈ  ڵ۾
*       03-12-11 - v1.2.1  : ü code 
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RURU
{
    /**
    * Debug flag
    *
    * @var	boolean 	$_debug
    * @access	public
    * @since    2003-08-11
    */
    var $_debug = false;

    /**
    * Constructor
    *
    * @param    bool    $debug
    * @access	public
    * @see	setDebug(), $_debug, $_destructor_list
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function RURU( $debug = false )
    {
        $classname = get_class( $this );

        $this->setDebug( $debug );

        if ( $this->_debug )
        { // in debug mode -  ϶
            printf( "Contructor called, class = <b>%s</b>\n<br>" , $classname );
        }

        while ( $classname )
        {
            $destructor = "_".$classname; // Destructor Method check
            if ( method_exists( $this , $destructor ) )
            { // If Exists..
                global $_destructor_list;
                $_destructor_list[] = &$this; // Add destructor list with reference
                break;
            }
            else
            {
                $classname = get_parent_class( $classname ); // θŬ  оδ
                //  θŬ destructor ã ..
            }
        }
    }

    /**
    * Destructor
    *
    * @access	public
    * @see	$_debug
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function _RURU()
    {
        if ( $this->_debug ) // in debug mode -  ϶
            printf( "Destructor called, class = <b>%s</b>\n<br>" , get_class( $this ) );
    }

    /**
    * Set debug mode
    *
    * @param    bool    $mode
    * @access	public
    * @see	$_debug
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function setDebug( $mode = false )
    {
        $this->_debug = $mode;
    }

    /**
    * Print debug message
    *
    * @param    string  $message
    * @access	public
    * @see	$_debug
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function debug( $message )
    {
        if ( $this->_debug )
            printf( "%s\n<br>" , $message );
    }

    /**
    * Get member variance
    *
    * @param    string  $str    member variance name
    * @return   mixed   return member variance
    * @access	public
    * @see	debug()
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function get( $str )
    {
        $this->debug( "RURU::get( $str )" );
        return $this->$str;
    } /* End of Function */

    /**
    * Set member variance
    *
    * @param    string  $str    member variance name
    * @param    string  $value  set value
    * @access	public
    * @see	debug()
    * @author	sunyruru<ruru@unfix.net>
    * @since    2003-08-11
    */
    function set( $str , $value )
    {
        $this->debug( "RURU::set( $str , $value )" );
        $this->$str = $value;
    } /* End of Function */
}


/**
* For Destroy All Resource
*
* @param    string  $msg  Output message
* @access	private
* @see	$_destructor_list
* @author	sunyruru<ruru@unfix.net>
* @since    2003-08-11
*/
function _destroy( $msg = "" )
{
    global $_destructor_list; // destructor list ҷ´

    // Ʈ obj ߰Ǿ 迭̰ ߰  ..
    if ( is_array( $_destructor_list ) && sizeof( $_destructor_list ) )
    {
        krsort( $_destructor_list ); // Ű ̿ 
        reset( $_destructor_list ); // 迭  Ŀ ʱȭ(while,list,each   ִ )
        while ( list( , $obj ) = each( $_destructor_list ) )
        {
            $classname = get_class( $obj );
            while ( $classname )
            {
                $destructor = "_$classname";
                if ( method_exists( $obj , $destructor ) )
                {
                    $obj->$destructor(); // destructor call
                    break;
                }
                else
                {
                    //  obj destructor Ƿ θŬ destructor ִ ƾѴ(ӹ)
                    $classname = get_parent_class( $classname );
                }
            }
        } // end of while
    }
    $_destructor_list = array(); // ʱȭ

    exit( $msg ); // exit process
}

register_shutdown_function( "_destroy" ); // PHP ũƮ   Լ Ѵ(Ҹ)

/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>