<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: RuruError.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

require_once "PEAR.php";
require_once dirname(__FILE__)."/Ruru.class.php";

// Message Store Array
$GLOBALS['_Ruru_Message_Store'] = array();
$GLOBALS['_Ruru_ErrorMessage_Store'] = array();

if ( !defined( "DIR_SEP" ) )
{
    if ( PEAR_OS == "Windows" )
        define( "DIR_SEP" , "\\" );
    else
        define( "DIR_SEP" , "/" );
}


/**
* RuruError Class
*
* RuruError class   óϱ  ϴ.
*  Ŭ PEAR Library PEAR_Error Class ӹ޽ϴ.
* 
* @since    2003-09-23
* @version	$Id: RuruError.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @extends  PEAR_Error
* @History
* <pre>
*       03-09-28 - v1.0.0  : RuruError Class ۼ
*       03-10-02 - v1.0.10 : RuruError Class ⺻  ڵ鷯    / ڵ鷯 ɹ ߰
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruError extends PEAR_Error
{
    /**
    * Prefix of all ruru error messages
    *
    * @var	    string      $error_message_prefix       error string scorp seperator
    * @access	public
    * @since    03-09-28
    */
    var $error_message_prefix = "RuruError: ";

    /**
    * Error Handler Object
    *
    * @var	    Object    $eHandle
    * @access	public
    * @since    03-10-02
    */
    var $eHandle = null;

    /**
    * Error Message Management
    *
    * @param    Mixed   $MsgOrObject    Object or Error message
    * @param    Mixed   $MsgOrObject    Object or Error message
    * @param    String  $file           file where the error occured
    * @param    String  $line           line number where the error occured
    * @return	type
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    
    */
    function RuruError( $MsgOrObject = 'Unknown Error!!' , $option = null , $file = __FILE__ , $line = __LINE__ )
    {
        $code = 0;
        $mode = PEAR_ERROR_CALLBACK;

        // option   ⺻  ڵ鷯 RuruErrorHandle ̿Ѵ
        if ( !isset( $option ) )
            $option = array( "RuruErrorHandler" , "RuruErrorHandler" );

        // Error Object 
        if ( is_object( $MsgOrObject ) && PEAR::isError( $MsgOrObject ) )
            $msg = sprintf("%s\n<br>File: %s\n<br>line: %d\n<br>" , $MsgOrObject->getMessage() , $file , $line );

        // Error Message 
        elseif ( is_string( $MsgOrObject ) )
            $msg = sprintf("%s\n<br>File: %s\n<br>line: %d\n<br>" , $MsgOrObject , $file , $line );

        // Ѵ ƴϸ..
        else
            $msg = sprintf("Unknown Error!!\n<br>File: %s\n<br>line: %d\n<br>" , $file , $line );

        PEAR_Error::PEAR_Error( $msg , $code , $mode , $options /* , $userinfo */ );
    }
} /* End of Class */


/**
* Message ϴ class
*
* error ޽ Ϲ ޽ Ͽ ǽð Ѵ
* 
* @since    2003-09-23
* @version	$Id: RuruError.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @extends  RURU
* @History
* <pre>
*       03-09-23 - v1.0.0  : RuruMsg Class ۼ
*       03-10-02 - v1.0.4  : addMsg(), addError() method ߰ / 
*       03-12-22 - v1.0.6  : ڿ SKINPATH ⺻  , setSkinName() ޼ҵ ۵ 
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruMsg extends PEAR
{
    /**
    * ޽ Ų̸
    *
    * @var	    string      $SKIN
    * @access	public
    * @since    03-09-25
    */
    var $SKIN = "ruru_basic";

    /**
    * ޽ Ų 
    *
    * @var	    string      $SKINPATH
    * @access	public
    * @since    03-09-25
    */
    var $SKINPATH;

    /**
    * RuruMsg Constructor Method
    *
    * @param    bool        $debug      default FALSE
    * @param    string      $skinpath
    * @param    string      $skin
    * @access	public
    * @see	    setSkinPath(), setSkinName()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function RuruMsg( $debug = false , $skinpath = '' , $skin = '' )
    {
        $this->PEAR( "RuruError" );

        $this->_debug = $debug;

        if ( isset( $skinpath ) && strlen( $skinpath ) > 1 )
            $this->setSkinPath( $skinpath );

        if ( isset( $skin ) && strlen( $skin ) > 1 )
            $this->setSkinName( $skin );
    }

    /**
    * RuruMsg Destructor Method
    *
    * @access	public
    * @see	    outputAll()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function _RuruMsg()
    {
        $this->_PEAR();
        $this->outputAll();
    }

    /**
    * Output All message
    *
    * Output All message, See also Global $_Ruru_Message_Store , $_Ruru_ErrorMessage_Store
    *
    * @return   bool
    * @access	public
    * @see	    $SKINPATH, $SKIN
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function outputAll()
    {
        global $_Ruru_Message_Store , $_Ruru_ErrorMessage_Store;

        $SKIN = $this->SKINPATH.DIR_SEP.$this->SKIN;

        //  
        if ( sizeOf( $_Ruru_ErrorMessage_Store ) > 0 )
        {
            $SKIN .= DIR_SEP."error.php";
            if ( !($string = implode( "\n<p>" , $_Ruru_ErrorMessage_Store )) ) $string = "Unknown Error!";
        }
        //   ޽
        elseif ( sizeOf( $_Ruru_Message_Store ) > 0 )
        {
            $SKIN .= DIR_SEP."msg.php";
            if ( !($string = implode( "\n<p>" , $_Ruru_Message_Store )) ) $string = "Unknown Message!";
        }
        else
            return false;

        include_once $SKIN;
    } /* End of Function */

    /**
    * Add General Message
    *
    * Ϲ ޽ ߰Ѵ(Static method)
    *
    * @param    string  $message    default "Unknown Message!"
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-10-02
    */
    function addMsg( $message = "Unknown Message!" )
    {
        global $_Ruru_Message_Store;

        $_Ruru_Message_Store[] = $message;
    } /* End of Function */

    /**
    * Add Error Message
    *
    *  ޽ ߰Ѵ(Static method)
    *
    * @param    string  $message    default "Unknown Error!"
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-10-02
    */
    function addError( $message = "Unknown Error!" )
    {
        global $_Ruru_ErrorMessage_Store;

        $_Ruru_ErrorMessage_Store[] = $message;
    } /* End of Function */

    /**
    * ޽  ֱٿ   ޽ ̾Ƴ(Static method)
    *
    * @return   bool
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function popError()
    {
        global $_Ruru_ErrorMessage_Store;
        return array_pop( $_Ruru_ErrorMessage_Store );
    } /* End of Function */

    /*
    function addError( $message = "Unknown Message!" , $file = __FILE__ , $line = __LINE__ )
    {
        $e =& new RuruError( $message , 0 , $file , $line );
    }
    */

    /**
    * Set SKIN Directory
    *
    * @param    string  $path
    * @return   bool
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function setSkinPath( $path )
    {
        if ( is_dir( $path ) && !is_link( $path ) )
        {
            $this->SKINPATH = $path;
            return true;
        }
        else return false;
    } /* End of Function */

    /**
    * Set SKIN Name
    *
    * @param    string  $skin
    * @return   bool
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function setSkinName( $skin )
    {
        $this->SKIN = $skin;
        return true;
    } /* End of Function */
} /* End of Class */


class RuruErrorHandle
{
    /**
    * RuruError Handler(Static method)
    *
    * @param    object      &$obj       pear class inherited object
    * @return   bool
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-28
    */
    function RuruErrorHandler( &$obj )
    {
        global $_Ruru_ErrorMessage_Store;

        if ( !is_object( $obj ) || method_exists( $obj , "getMessage" ) )
            return false;

        $_Ruru_ErrorMessage_Store[] = $obj->getMessage();
        return true;
    } /* End of Function */
} /* End of Class */


/**
* Error Handling function
*
* @param    int     $errno      Error Number
* @param    string  $errmsg     Error String
* @param    string  $file       File name of occur error
* @param    int     $line       Line of error occur file
* @param    mixed   $vars
* @return	type
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    
*/
function ruruErrorHandler($errno, $errmsg, $file, $line, $vars)
{
    if ( !$errno ) $errno = 0;

    $errortype = array (
        0   =>  "Unknown Error",
        1   =>  "Error",
        2   =>  "Warning",
        4   =>  "Parsing Error",
        8   =>  "Notice",
        16  =>  "Core Error",
        32  =>  "Core Warning",
        64  =>  "Compile Error",
        128 =>  "Compile Warning",
        256 =>  "User Error",
        512 =>  "User Warning",
        1024=>  "User Notice"
    );

    switch ( $errno )
    {
        case 8: // Notice skip
        break;
    
        default:
            RuruMSG::addError( $errortype[$errno]." : $errmsg in $file on line $line\n" );
        break;
    }
} /* End of Function */


/**
* Output message & move page & some tags
*
* @param    String  $str
* @param    int     $flag
*     $flag == 0 : Error message & move page
*     $flag == 1 : Message & move page
*     $flag == 2 : Error message & Back button
*     $flag == 3 : Message & Close button
*     $flag == 4 : Error message & User button
*     $flag == 5 : Message & User button
* @param    string  $url
* @param    int     $sec
* @param    string  $btn    Set button text
* @return	type
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-10-02
*/
function msgBox( $str = '' , $flag = 0 , $url = '' , $sec = 0 , $btn = '' )
{
    switch ( $flag )
    {
        case 0:
            $str .= "<meta http-equiv=refresh content=' $sec ; url=$url '>";
            RuruMSG::addError( $str );
        break;
    
        case 1:
            $str .= "<meta http-equiv=refresh content=' $sec ; url=$url '>";
            RuruMSG::addMsg( $str );
        break;
    
        case 2:
            $str .= "\n<br>\n<input class=btnBack type=button onClick='javascript:history.go(-1);' value='Back'>\n";
            RuruMSG::addError( $str );
        break;
    
        case 3:
            $str .= "\n<br>\n<input class=btnClose type=button onClick='javascript:window.close();' value='Close'>\n";
            RuruMSG::addMsg( $str );
        break;
    
        case 4:
            $str .= "\n<br>\n$btn\n";
            RuruMSG::addError( $str );
        break;
    
        case 5:
            $str .= "\n<br>\n$btn\n";
            RuruMSG::addMsg( $str );
        break;
    }
    exit;
}

/* Use Example

// Error Handler
error_reporting( E_ALL & ~E_NOTICE );
set_error_handler( "ruruErrorHandler" );

*/

/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>