<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: RuruMySQL.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

if ( !defined( "RURU_DB_LAYER" ) )
{
    /**
    * Set DB Layer type
    *
    * @const    string  "mysql"
    * @access   public
    * @author	sunyruru<ruru@unfix.net>
    * @copyright	http://ruru.unfix.net
    */
    define( "RURU_DB_LAYER" , "mysql" );


require_once dirname(__FILE__)."/Ruru.class.php";
require_once dirname(__FILE__)."/RuruError.class.php";
require_once dirname(__FILE__)."/benchmark.class.php";

/**
* RuruMySQL class  MySQL    ׸ ڵȭŰ  ϴ.
*  Ŭ RURU ӹ޽ϴ.
*  Ŭ BenchMark Class մϴ.
* 
* @since    2001
* @version	$Id: RuruMySQL.class.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*   2003-03-03 - v2.1.37
*   2003-05-13 - v2.1.52 : MYSQL  ɸ ð üũϰ,   .
*   2003-06-06 - v2.1.56 : ߸ BenchmarkǴ  
*   2003-08-11 - v2.1.58 : ߸ include Ǵ  
*   2003-08-11 - v2.1.64 :  庰  ޼ҵ 
*   2003-08-14 - v2.1.69 :  庰  query(array)  ʴ  ذ
*   2003-08-15 - v2.1.73 : _fetch ׿ ٸ    ʴ  (MYSQL::fetch())
*
*   2003-09-12 - v3.0.0  : Base Library PEAR Library ϸ鼭 ü ڵ۾
*   2003-09-28 - v3.0.1  : Error Class PEAR_Error RuruError Class 
*   2003-10-02 - v3.0.11 : smallQuery(), queryResult(), fetch() ޼ҵ  
*   2003-10-03 - v3.0.14 : fetch() ޼ҵ Ƽ  ȯ ù ε ̻    
*   2003-10-03 - v3.0.16 : queryResult(), fetch() ޼ҵ fetch assoc   ʴ  ذ
*   2003-12-12 - v3.1.1  : ڵŸ 
*   2003-12-28 - v3.1.18 : queryResult(), affectedRows() ʿ ڵ  / ӵ ,  
*   2003-12-29 - v3.1.19 : query(), affectedRows(), listTables() Լ ȯǴ ڷ  
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruMySQL extends RURU
{
    /**
    * Set Database configuration data
    *
    * @var	array	$CONF
    * @access	public
    * @since    03-11-27
    */
    var $CONF = array();

    /**
    *  Ŭ ̿    ִ 
    *
    * @var	integer     $QUERYCNT
    * @access	public
    * @since    03-05-13
    */
    var $QUERYCNT = 0;

    /**
    * table   ƴ ϴ flag
    *
    * @var	boolean 	$LOCK
    * @access	public
    * @since    03-05-13
    */
    var $LOCK = false;

    /**
    * MySQL  Benchmark  Object
    *
    * @var	Object	Benchmakr   $Bench    Ŭ ܺο νϽ ü ۷  ̴
    * @access	public
    * @since    03-09-12
    */
    var $Bench;

    /**
    * MySQL ResultSet ӽ÷  ִ ̴.
    *
    * @var  mixed	$RS
    * @access	public
    * @since    03-09-20
    */
    var $RS;

    /**
    * mysql_fetch_array() ̿ؼ ResultSet fetchؿ ͸  ִ 迭 2 迭̴
    *
    * @var  array	$DATA
    * @access	public
    * @since    03-09-20
    */
    var $DATA = array();

    /**
    * mysql_num_rows()   ResultSet īƮ  ̴
    *
    * @var  integer     $DATACNT
    * @access	public
    * @since    03-09-20
    */
    var $DATACNT = 0;

    /**
    * query ߴ  ͷ Ǿ ִ.
    * (ʿ member variance Ŀ   ִ  ̴)
    *
    * @var  int $DATACNT
    * @access	public
    * @since    03-05-13
    */
    var $QUERY = array();

    /**
    * MySQL Connection Resource  ִ member variance̴.
    *
    * @var  mixed    $CONN
    * @access	public
    * @since    03-09-20
    */
    var $CONN;


    /**
    * RuruMySQL Constructor Method
    *
    *       $conf[0] = Hose
    *       $conf[1] = User id
    *       $conf[2] = User pass
    *       $conf[3] = DB name
    *
    * @param    boolean  $debug
    * @param    array    &$conf  (reference)
    * @param    object  Benchmark   &$Bench      by reference
    * @access	public
    * @see  $Bench, $CONF, DB_conn()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function RuruMySQL( $debug = false , &$conf , &$Bench )
    {
        $this->RURU( $debug ); // RURU class constructor 
        $this->Bench =& $Bench;

        $this->CONF =&$conf;
        $this->DB_conn();
    }

    /**
    * RuruMySQL Destructor Method
    *
    * DB_free() method call for free all MySQL Resource.
    *
    * @param    bool    $debug
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function _RuruMySQL()
    {
        $this->_RURU();
        $this->DB_free();
    }

    /**
    * MySQL  Ǿִ  Ȯϴ ޼ҵ
    *
    * @return   bool
    * @access	public
    * @see  $CONN
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function isConnect()
    {
        return ( isset( $this->CONN ) && is_resource( $this->CONN ) ) ? true : false;
    } /* End of Function */

    /**
    * Database Connect method
    * 
    * Use Database configuration data in member variance, $this->CONF(array)
    *
    * @return   bool
    * @access	public
    * @see  sqlError()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-11-28
    */
    function DB_conn()
    {
        $this->debug( "RuruMySQL::DB_conn()" );

        $this->Bench->startBench( "RuruMySQL::DB_conn" );
        $this->CONN = @mysql_connect( $this->CONF["HOST"] , $this->CONF["ID"] , $this->CONF["PASS"] )
            or exit( $this->sqlError( "MYSQL Error exception! on 'mysql_connect'" ) );
        $this->Bench->pauseBench( "RuruMySQL::DB_conn" );

        if ( $this->isConnect() )
        {
            $this->Bench->startBench( "RuruMySQL::DB_conn" );
            @mysql_select_db( $this->CONF["DB"] , $this->CONN );
            $this->Bench->pauseBench( "RuruMySQL::DB_conn" );
            $this->sqlError();

            return true;
        }
        return false;
    }

    /**
    * MySQL Util Destructor ȣ ޼ҵ - SQL ҽ Ѵ
    *
    * @access	public
    * @see  isConnect(), sqlError()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-12
    */
    function DB_free()
    {
        if ( $this->isConnect() ) @mysql_close() or $this->sqlError();
    }

    /**
    * Query and return fetch data
    *
    * @param    string    $query
    * @access	public
    * @see  query(), affectedRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function queryResult( $query )
    {
        $this->debug( "RuruMySQL::queryResult()" );
        return ( $this->query( $query ) && $this->DATACNT ) ? $this->fetch() : false;
    }

    /**
    * Query method
    *
    * @param    string    $query
    * @access	public
    * @see  $CONN, $RS, $QUERY, $QUERYCNT, isConnect(), DB_conn(), sqlError()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function query( $query )
    {
        $this->debug( "RuruMySQL::query()" );

        if ( !$this->isConnect() ) $this->DB_conn();
        $this->QUERY[] = $query;
        $this->QUERYCNT++;

        unset( $this->RS );

        $this->Bench->startBench( "DB" );
        $this->RS = @mysql_query( $query , $this->CONN );
        $this->Bench->pauseBench( "DB" );
        $this->sqlError();

        $this->affectedRows();

        return $this->RS;
    }

    /**
    * Fetch all data from ResultSet resource
    *
    * @return   array
    * @access	public
    * @see  $DATA, $RS, seek(), isConnect(), DB_conn(), sqlError()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function fetch()
    {
        $this->debug( "RuruMySQL::fetch()" );
        if ( !$this->isConnect() ) $this->DB_conn();

        unset( $this->DATA ); /** in 03-08-15 fetch ʱȭ  ʾ ߸  ȯϴ   */
        $this->DATA = array();

        $this->seek( 0 ); // rewind

        if ( $this->RS && is_resource( $this->RS ) )
        {
            $this->Bench->startBench( "DB" );
            while ( $this->DATA[] = @mysql_fetch_array( $this->RS ) ) $this->sqlError();
            // mysql_fetch_assoc() is better
            array_pop( $this->DATA ); // Ǯ ʴ  -_-;;
            $this->Bench->pauseBench( "DB" );
        }
        return $this->DATA;
    }

    /**
    * Free ResultSet resource
    *
    * @param    mixed    &$RS
    * @access	public
    * @see  $RS
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function freeResult( &$RS )
    {
        $this->debug( "RuruMySQL::freeResult()" );
        $this->Bench->startBench( "DB" );
        $return = @mysql_free_result( $RS ) or $this->sqlError();
        $this->Bench->pauseBench( "DB" );

        return $return;
    }

    /**
    * Get rows from ResultSet
    *
    * @access	public
    * @see  $RS, $DATACNT
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function affectedRows()
    {
        $this->debug( "RuruMySQL::affectedRows()" );

        if ( !$this->QUERYCNT ) return false; //   

        $this->Bench->startBench( "DB" );
        $this->DATACNT = 0;

        // select  ϸ mysql_num_rows() Լ Ѵ
        if ( eregi( "^select" , trim( $this->QUERY[$this->QUERYCNT-1] ) ) )
            $this->DATACNT = @mysql_num_rows( $this->RS );
        else
            $this->DATACNT = @mysql_affected_rows();

        $this->Bench->pauseBench( "DB" );

        return $this->DATACNT;
    }

    /**
    * Seek data
    *
    * @return   bool
    * @param    integer     $row
    * @access	public
    * @see  $RS
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function seek( $row )
    {
        $this->debug( "RuruMySQL::seek( $row )" );
        if ( $this->RS )
        {
            $this->Bench->startBench( "DB" );
            @mysql_data_seek( $this->RS , $row );
            $this->Bench->pauseBench( "DB" );

            $this->sqlError();
            return true;
        }
        else return false;
    }

    /**
    * Ѱ ʵ   ö  
    *
    * @param    string  $query
    * @access	public
    * @see  queryResult(), $DATA
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function smallQuery( $query )
    {
        $this->debug( "RuruMySQL::smallQuery()" );
        $this->queryResult( $query );
        return $this->DATA[0][0];
    }

    /**
    *  üũϰ ޽ óѴ
    *
    * @param    string    $msg
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    * @throw    RuruMsg
    */
    function sqlError( $msg = "" )
    {
        if ( mysql_error() || mysql_errno() )
        {
            $this->debug( "RuruMySQL::sqlError( $msg ) - ".$error );

            $msg = ( $msg ) ? "(".$msg.")" : "";
            $error = "<b>" . mysql_errno() . "</b> : " . mysql_error() . $msg;
            if ( $this->QUERY[$this->QUERYCNT-1] ) $error .= "<br>Query : " . $this->QUERY[$this->QUERYCNT-1];
            if ( $this->isConnect() ) $this->DB_free();
            // exit( $error ); // ޽ ϸ鼭 Ѵ.

            // ޽ ϸ鼭 Ѵ.
            if ( is_object( $GLOBALS[MSG] ) && method_exists( $GLOBALS[MSG] , 'addError') )
            {
                $MSG =& $GLOBALS[MSG];
                $MSG->addError( $error );
            }
            else
                _destroy( $error );
        }
    } /* End of Function */
} /* End of Class */


/**
* RuruSQLUtil class  MySQL   SQL Լ Util ϴ.
*        Ŭ RURU Class ӹ޽ϴ.
*        Ŭ BenchMark Class մϴ.
* 
* @since    2003-09-20
* @version	v 1.1.1 sunyruru Exp $
* @author	sunyruru<ruru@unfix.net>
* @package	RLib
* @History
* <pre>
*   03-09-20 - v1.0.0 : RuruSQLUtil Class 
*   03-10-02 - v1.0.8 : getCount() ޼ҵ  
*   03-11-29 - v1.1.0 : ڵ
*   03-12-13 - v1.1.1 : ڵŸ 
*   03-12-17 - v1.1.4 : listTables() tableExist()޼ҵ  
* </pre>
* @copyright	http://ruru.unfix.net
*/
class RuruSQLUtil extends RURU
{
    /**
    * RuruMySQL Object reference ޾Ƽ  member variance
    *
    * @var	object  RuruMySQL  $rSQL
    * @access	public
    * @since    03-09-20
    */
    var $rSQL;


    /**
    * Constructor method
    *
    * @param    object    RuruMySQL     &$RuruMySQL
    * @access	public
    * @see  $rSQL
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function RuruSQLUtil( &$RuruMySQL )
    {
        $this->rSQL =& $RuruMySQL;
        $this->RURU( $this->rSQL->_debug );
    }

    /**
    * Destructor method
    *
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function _RuruMySQL()
    {
        unset( $this->rSQL );
        $this->_RURU();
    }

    /**
    * Query from sql file
    *
    * @param    string    $sqlFile  sql file path.
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function queryFile( $sqlFile )
    {
        $this->debug( "RuruSQLUtil::queryFile()" );
        if ( is_file( $sqlFile ) && !is_link( $sqlFile ) && is_readable( $sqlFile ) )
            return $this->rSQL->query( implode( "\n" , @File( $sqlFile ) ) );
        else
            return false;
    }

    /**
    * Get list tables from currunt database
    *
    * @return   array   table list
    * @access	public
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function listTables()
    {
        $this->debug( "RuruSQLUtil::listTables()" );
        $db = $this->rSQL->CONF["DB"];

        $this->rSQL->Bench->startBench( "DB" );
        $this->rSQL->RS = @mysql_list_tables( $db );
        $this->rSQL->Bench->pauseBench( "DB" );
        $this->rSQL->sqlError();

        if ( is_resource( $this->rSQL->RS ) && $cnt = @mysql_affected_rows() )
        {
            $this->rSQL->DATA = array();
            for ( $i = 0 ; $i < $cnt ; $i++ )
            {
                $this->rSQL->Bench->startBench( "DB" );
                $this->rSQL->DATA[] = @mysql_tablename( $this->rSQL->RS , $i );
                $this->rSQL->Bench->pauseBench( "DB" );
                $this->rSQL->sqlError();
            }
            return $this->rSQL->DATA;
        }
        return false;
    }

    /**
    * Check table exists
    *
    * array tableExist( tblName(array or string) )
    *
    * @return   array
    * @param    string  $tblName
    * @access	public
    * @see      listTables()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function tableExist( $tblName )
    {
        $this->debug( "RuruSQLUtil::tableExist()" );

        $return = array(); // üũ  ̺ ȯѴ

        $data = $this->listTables();

        if ( is_array( $tblName ) ) // μ 迭϶
        {
            for ( reset( $tblName ) ; $var = current( $tblName ) ; next( $tblName ) )
                if ( in_array( $var , $data ) ) $return[] = $var;
            return $return; // sizeOf( $return ) == 0  ̺  ִ ̴
        }
        else
        { // Just One table Check
            return in_array( $tblName , $data );
        }
        return false;
    }

    /**F
        @Name: dropTable@$
        @Type: boolean@$
        @Param: String $tblName[, $tblName[, ...]]@$
        @Access: public@$
        @Version: 1.1.0@$
        @Date: 03-09-20@$
        @Last Modified: 03-11-29@$
        @Detail: Drop tables@$
        @Author: sunyruru<ruru@unfix.net>@$
    */
    /**
    * Drop tables
    *
    * bool dropTable( $tbl[, $tbl[, $tbl[, ...]]] )
    *
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function dropTable()
    {
        $this->debug( "RuruSQLUtil::dropTable()" );

        $argc = func_num_args();
        $argv = func_get_args();

        if ( $argc )
            for ( $i = 1 , $tbl = $argv[0] ; $i < $argc ; $i++ )
                $tbl .= "," . $argv[$i];

        $this->rSQL->query( "drop table $tbl" ) or $this->rSQL->sqlError();
        return true;
    }

    /**
    * Get password that use MySQL password() function
    *
    * string getPassword( $password )
    *
    * @return   string
    * @param    string  $password
    * @access	public
    * @see  smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function getPassword( $password )
    {
        $this->debug( "RuruSQLUtil::getPassword()" );
        return $this->rSQL->smallQuery( "select password('$password')" );
    }

    /**
    * Get tuple count from table
    *
    * int getCount( $tblName )
    *
    * @return   int
    * @param    string    $tblName
    * @access	public
    * @see  smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function getCount( $tblName )
    {
        $this->debug( "RuruSQLUtil::getCount()" );
        return $this->rSQL->smallQuery( "select count(*) from ".$tblName );
    }

    /**
    * Optimize tables
    *
    * mixed optimizeTables( $tblName[, $tblName[, ...]] )
    *
    * @return   mixed
    * @param    string    $tblName  Available Multiple tables
    * @access	public
    * @see  query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function optimizeTables( $tblName )
    {
        $this->debug( "RuruSQLUtil::optimizeTables()" );

        $argc = func_num_args();
        $argv = func_get_args();

        if ( $argc > 0 )
            for ( $i = 0 ; $i < $argc ; $i++ )
                $this->rSQL->query( "optimize table " . $argv[$i] );
    }

    /**
    * Lock tables
    *
    * int lockTables( $mode , $tblName[, $tblName[, ...]] )
    *
    * $mode : write or read         Lock mode
    *
    * @return   int
    * @param    boolean     $mode
    * @param    string      $tblName
    * @access	public
    * @see  $LOCK, query()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function lockTables( $mode = false )
    {
        $this->debug( "RuruSQLUtil::lockTables()" );
        $argc = func_num_args();
        $argv = func_get_args();

        if ( !$mode ) $mode = "write";
        if ( $argc == 2 ) $query = "lock tables $argv[1] $mode";
        elseif ( $argv > 2 )
        {
            $query = "lock tables " . $argv[1] . " " . $mode . " , ";
            for ( $i = 2 , $add ="" ; $i < $argc ; $i++ )
            {
                $add .= $argv[$i] . " " . $mode;
                if ( $i != ( $argc - 1 ) ) $add .= " , ";
            }
            $query .= $add;
        }
        else return false;

        $this->LOCK = true;
        return $this->query( $query , 1 );
    }

    /**
    * unLockTables()
    *
    * void unLockTables()
    *
    * @access	public
    * @see  query(), $LOCK
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function unLockTables()
    {
        $this->debug( "RuruSQLUtil::unLockTables()" );
        if ( $this->LOCK ) $this->query( "unlock tables" );
        $this->LOCK = false;
    }

    /**
    * Select query
    *
    * array[row][field] selectQuery( $table , $fields = "*" , $options = "" )
    *
    * @return   array   2 迭 ȯȴ
    * @param    string  $table      table name
    * @param    string  $fields     select fields
    * @param    string  $options    select options
    * @access	public
    * @see      queryResult()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function selectQuery( $table , $fields='*' , $options='' )
    {
        $this->debug( "RuruSQLUtil::selectQuery()" );
        return $this->rSQL->queryResult( "select $fields from $table $options" );
    }

    /**
    * Insert Query
    *
    * int insertQuery( $table , $fields , $options )
    *
    * @return   int
    * @param    string  $table      table name
    * @param    string  $fields
    * @param    string  $options
    * @access	public
    * @see      queryResult(), affectedRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function insertQuery( $table , $fields , $options )
    {
        $this->debug( "RuruSQLUtil::insertQuery()" );
        $this->rSQL->queryResult( "insert into $table ($fields) values ($options)" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Update query
    *
    * int updateQuery( $table , $match , $options )
    *
    * @return   int
    * @param    string  $table  table name
    * @param    array   $match  associan array.  key is field, value is value
    * @param    string  $options
    * @access	public
    * @see      addSlash(), queryResult(), affectedRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function updateQuery( $table , $match , $options )
    {
        $this->debug( "RuruSQLUtil::updateQuery()" );
        if ( !is_array( $match ) ) return false;

        $var = '';
        foreach ( $match as $key=>$value ) $var .= "$key='".addSlash( $value )."' ";
        $this->rSQL->queryResult( "update $table set $var where $options" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Delete query
    *
    * int deleteQuery( $table , $options="" )
    *
    * @return   int
    * @param    string  $table  table name
    * @param    string  $options
    * @access	public
    * @see      queryResult(), affecredRows()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function deleteQuery( $table , $options='' )
    {
        $this->debug( "RuruSQLUtil::deleteQuery()" );
        if ( $options ) $where = ' where ';
        $this->rSQL->queryResult( "delete from $table $where $options" );
        return $this->rSQL->affectedRows();
    }

    /**
    * Transform IP Address to Number
    *
    * int   aton( $ip )
    *
    * @return   int     transformed IP Address
    * @param    string  $ip
    * @access	public
    * @see      smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function aton( $ip )
    {
        $this->debug( "RuruSQLUtil::aton( $id )" );
        return $this->rSQL->smallQuery( "select inet_aton('$ip')" );
    }

    /**
    * Transform Number to IP Address
    *
    * string    ntoa( $num )
    *
    * @return   string  IP Address
    * @param    int     $num
    * @access	public
    * @see      smallQuery()
    * @author	sunyruru<ruru@unfix.net>
    * @since    03-09-20
    */
    function ntoa( $num )
    {
        $this->debug( "RuruSQLUtil::ntoa( $num )" );
        return $this->rSQL->smallQuery( "select inet_ntoa('$num')" );
    }
}// end of class

} // End of DB Layer


/* Example

echo "<pre>";
$SQL =& new RuruMySQL( true , array( "localhost" , "sunyruru" , "sunyruru" , "sunyruru" ) );
$SQL->query( "select password('password')" );
echo RURU_DB_LAYER;
print_r( $SQL->fetch() );
print_r( $SQL->Bench );
print_r( $SQL );
echo $SQL->get( "DATACNT" );
$SQL->set( "DATACNT" , 2 );
echo $SQL->get( "DATACNT" );
*/


/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>