<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: config.php,v 1.5 2004/04/08 00:02:49 sunyruru Exp $


////////////////////////////////////////////
//                          //
////////////////////////////////////////////

$CONF[HOST] = "localhost"; /* Set DB Host with Use port -> ex) 
"localhost:3306" */
$CONF[ID]   = "sunyruru";  /* Set DB User ID */
$CONF[PASS] = "";  /* Set DB User Password */
$CONF[DB]   = "sunyruru";  /* Set Database name */

$CONF[TBL]  = "rc";    /*  table */
$CONF[DBMS] = "mysql"; /*  Database */

$CONF[DEBUG]   = false; /* Debug Mode Select true(1) or false(0) */
$CONF[LANG]    = "kr";  /*   */
$CONF[PEARDIR] = dirname(__FILE__)."/pear"; /* ex) /usr/php/pear */
$CONF[TPLDIR] = dirname(__FILE__)."/Smarty"; /* ex) /usr/php/template_ */

////////////////////////////////////////////



$CONF[NAME]    = "rSCMS"; /* Program Name */
$CONF[VERSION] = "v1.0.0-dev"; /* Program Version */

$CONF[ERRORMODE] = E_ALL & ~E_NOTICE; /* Program ErrorMode */
//$CONF[ERRORMODE] = E_ALL ; /* Program ErrorMode */

$CONF[DBDSN] = $CONF[DBMS]."://".$CONF[ID].":".$CONF[PASS]."@".$CONF[HOST]."/".$CONF[DB];


if ( !is_string($_CONF[PEARDIR]) || !strlen($_CONF[PEARDIR])
    || !is_dir($_CONF[PEARDIR]) || !is_file($_CONF[PEARDIR]."/PEAR.php") )
        $_CONF[PEARDIR] = ini_get( "include_path" );

if ( !is_string($_CONF[PEARDIR]) || !strlen($_CONF[PEARDIR])
    || !is_dir($_CONF[PEARDIR]) || !is_file($_CONF[PEARDIR]."/PEAR.php") )
        exit( "Critical Error : PEAR Library path is incorrect!!" );
else
    ini_set( "include_path" , $_CONF[PEARDIR] );


////////////////////////////////////////////
//        Basic Constant Variables        //
////////////////////////////////////////////

define( "RC_ROOT" , $_DIR[ROOT] = dirname( __FILE__ ) );
    define( "TPL" , $_DIR[TPL] = $_CONF[TPLDIR] );
    define( "RC_LIB" , $_DIR[LIB] = RC_ROOT."/library" );
    define( "RC_RLIB" , $_DIR[RLIB] = RC_ROOT."/RLib1.0" );
    define( "RC_LANG" , $_DIR[LANG] = RC_ROOT."/language/".$_CONF[LANG] );
    define( "RC_SKIN" , $_DIR[SKIN] = RC_ROOT."/skin" );

    define( "RC_MODULE" , $_DIR[MODULE] = RC_ROOT."/module" );
        define( "RC_ADMIN" , $_DIR[MODULE_ADMIN] = RC_MODULE."/admin" );
        define( "RC_BOARD" , $_DIR[MODULE_BOARD] = RC_MODULE."/board" );

    define( "RC_DATA" , $_DIR[DATA] = RC_ROOT."/data" );
        define( "RC_SESS" , $_DIR[DATA_SESS] = RC_DATA."/".$CONF[TBL]."_rcSession" );
        // icon/*, board/*, mail/*, install/*, update/*, temp/*
        define( "RC_LOG" , $_DIR[DATA_LOG] = RC_DATA."/".$_CONF[TBL]."_LOG" );

define( "RC_TBL" , $_CONF[TBL] );
define( "RC_NAME" , $_CONF[NAME] );
define( "RC_VERSION" , $_CONF[VERSION] );
define( "RC_DEBUG" , $_CONF[DEBUG] );


//ini_set( "track_vars"           , false );
ini_set( "track_errors"         , true  );
ini_set( "html_errors"          , false );
ini_set( "magic_quotes_runtime" , false ); // set_magic_quotes_runtime(0);


// SESSION 
session_save_path( RC_SESS );
session_start(); // ǹ׷  output ̻

//ob_start("ob_gzhandler");
//ob_implicit_flush( true );

// Variables -- $_SQL, $_CONF, $_DIR, $_FILE, $_URL, $_TBN

// File Array
$_FILE = array(
    "admin" => "admin.php" ,
    "board" => "rcom.php"  ,
    "join"  => "join.php"  ,
    "info"  => "info.php"  ,
);


// URL Array
$_URL = array(
    "host" => "" ,
    "root" => ""
);

// SQL Table Array
$_TBN = array(
    "table"    => RC_TBL,
    "message"  => RC_TBL."_message"  ,
    "category" => RC_TBL."_category" ,
    "member"   => RC_TBL."_member"   ,
    "admin"    => RC_TBL."_admin"    ,
    "comment"  => RC_TBL."_comment"  ,
    "group"    => RC_TBL."_group"    ,
    "site"     => RC_TBL."_site"
    // , "board" => "߿ "
);


////////////////////////////////////////////
//           Basic Classes Load           //
////////////////////////////////////////////

// Load PEAR Library
require_once "PEAR.php"; /* In include path */
require_once "DB.php";

require_once TPL."/libs/Smarty.class.php"; /* Use Smarty */
// require_once TPL."/Template_.php"; /* Use Template_ */

// Load Function Library files
require_once RC_LIB."/rcom.lib.php";
require_once RC_LIB."/function.lib.php";
require_once RC_LIB."/initialize.lib.php";

// Load Class files
//require_once RC_RLIB."/Ruru.class.php";
require_once RC_RLIB."/RuruError.class.php";
require_once RC_RLIB."/benchmark.class.php";
//require_once RC_RLIB."/RuruINI.class.php";
require_once RC_RLIB."/RuruMySQL.class.php";


// Object Instance
$Bench =& new BenchMark( RC_DEBUG );
$Bench->startBench( RC_NAME." ".RC_VERSION ); // RuruCommunity  ð 

// Error Classes
$EH =& new RuruErrorHandle;
$MSG =& new RuruMsg( RC_DEBUG , RC_SKIN.DIR_SEP."msg" , "sakk_simpledark" ); // Message Classes

// Error Handler
error_reporting( $_CONF[ERRORMODE] );
set_error_handler( "ruruErrorHandler" );
PEAR::setErrorHandling( PEAR_ERROR_CALLBACK , array( &$EH , "RuruErrorHandler" ) );

// MySQL
$SQL =& new RuruMySQL( RC_DEBUG , $_CONF[DBDSN] , $Bench );
if (DB::isError($SQL)) exit($SQL->DB->getMessage()); // ref. PEAR/DB.php

// MySQL Util
$SQLU =& new RuruSQLUtil( $SQL );

if ( !defined( "DIR_SEP" ) )
{
    if ( PEAR_OS == "Windows" ) // ref. PEAR/PEAR.php
        define( "DIR_SEP" , "\\" );
    else
        define( "DIR_SEP" , "/" );
}


// ŷ  
if ( ereg( "HTTP_" , $REQUEST_URI ) ) msgBox( "ٱ -_-+" , 2 );



// Initialize Super variance

// board config initialize
if ( $code = gV("code") ) @initPAGE( &$_PAGE , $code );
$group = (gV("group")) ? gV("group") : $_PAGE[grp];

// group config initialize
if ( $group ) @initGRP( &$_GRP , $group );
$site = (gV("site")) ? gV("site") : $_GRP[site];

// site config initialize
if ( $site ) @initSITE( &$_SITE , $site );

autoLogin(); // ڵα ϴ  ڵα óѴ
if ( isMember() ) initUSR(); // user config initialize

$href = initGet();

/*
select * from
           rc_site AS s, rc_group AS g
           where s.no = 1 and g.site = 1
					 group by g.site;
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>
