<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: form.lib.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $

require_once dirname(__FILE__)."/function.lib.php";

/**F
    @Name: radioYesNo@$
    @Type: Array
        [yes] => if selected ' checked'
        [no] => if selected ' checked'
    @$
    @Param: int $iButton
        0 => [no] to ' checked'
        1 => [yes] to ' checked'
    @$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-10-03@$
    @Last Modified: 03-10-03@$
    @Detail: Make radio Yes or No button array@$
    @Since: 3.0.102-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function radioYesNo( &$iButton )
{
    $tmp = $iButton;
    $iButton = array();
    $iButton[yes] = ''; $iButton[no] = '';
    ( !$tmp )? ($iButton[no] = ' checked') : ($iButton[yes] = ' checked');

    return $iButton;
} /* End of Function */

/**F
    @Name: radioYesNoArray@$
    @Type: Reference void@$
    @Param: Array $arr@$
    @Param: Array $arr2@$
    @Param: int $mode@$
    @Access: public@$
    @Version: 1.0.3@$
    @Date: 03-10-04@$
    @Last Modified: 03-10-26@$
    @Detail: Make radio Yes or No button from Array@$
    @Since: 3.0.113-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function radioYesNoArray( &$arr , &$arr2 , $mode = 1 )
{
    if ( !is_array( $arr ) && !is_array( $arr2 ) )
        return false;

    for ( reset( $arr ) ; list( $k , $v ) = each( $arr ) ; )
    {
        if ( in_array( $k , $arr2 ) )
        {
            $GLOBALS[$k] = array();
            $GLOBALS[$k][$v] = ' checked';
        }
        elseif ( $mode )
        {
            $GLOBALS[$k] = "";
            $GLOBALS[$k] = str_replace( '"' , '&quot;' , $v );
        }
    } /* End of For */
    return true;
} /* End of Function */

/**F
    @Name: radioArray@$
    @Type: Reference void@$
    @Param: Array $arr@$
    @Param: Array $arr2@$
    @Param: int $mode@$
    @Access: public@$
    @Version: 1.0.1@$
    @Date: 03-10-09@$
    @Last Modified: 03-10-26@$
    @Detail: Make radio button from Array@$
    @Since: 3.0.138-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function radioArray( &$arr , &$arr2 , $mode = 0 )
{
    if ( !is_array( $arr ) && !is_array( $arr2 ) )
        return false;

    for ( reset( $arr ) ; list( $k , $v ) = each( $arr ) ; )
    {
        if ( in_array( $k , $arr2 ) )
        {
            $GLOBALS[$k] = array();
            $GLOBALS[$k][$v] = ' checked';
        }
        elseif ( $mode )
        {
            $GLOBALS[$k] = "";
            $GLOBALS[$k] = str_replace( '"' , '&quot;' , $v );
        }
    } /* End of For */
    return true;
} /* End of Function */

/**F
    @Name: selectDirList@$
    @Type: String $selectTag@$
    @Param: String $directory Search directory name@$
    @Param: String $selectVariable Selected directory name@$
    @Access: public@$
    @See: getDirList()[function.lib.php]@$
    @Version: 1.0.0@$
    @Date: 03-10-03@$
    @Last Modified: 03-10-03@$
    @Detail: Make Option Tag with Directory list@$
    @Since: 3.0.81-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function selectDirList( $directory , $selectVariable = "" )
{
    $dir = getDirList( $directory );

    for ( $i = 0 , sort( $dir ) , $cnt = sizeof( $dir ) , $selectTag = '' ; $i < $cnt ; $i++ )
    {
        if ( strlen( $dir[$i] ) > 30 || !is_dir( $directory."/".$dir[$i] ) ||
            is_link( $directory."/".$dir[$i] ) ) continue;

        if ( $dir[$i] == $selectVariable )
            $selected = " selected";

        $selectTag .= "<option class=dirOption value='".$dir[$i]."'".$selected.">".$dir[$i]."</option>\n";
        $selected = null;
    }
    return $selectTag;
} /* End of Function */


/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>