<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: function.lib.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $


/**
*   Է ޾Ƽ    ȯѴ
*
* @param    int     $size
* @param    string  $format     set output format
* @return	int     file size
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-12-22
*/
function getFileSize( $size , $format = "%d" )
{
    $array = array( 1 , 1000 , 1000*1000 , 1000*1000*1000 );
    $ext = array( "Byte" , "KB" , "MB" , "GB" );

    for ( $i = sizeof( $array )-1 ; $i >= 0 ; $i-- )
        if ( floor($size/$array[$i]) )
            return sprintf( $format , $size/$array[$i] ).$ext[$i];
} /* End of Function */

/**
*  θ Է ޾Ƽ    ȯѴ
*
* @param    string      $filepath
* @return	int         file size
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-12-22
*/
function getFileSizeFromFile( $filepath )
{
    if ( is_file( $filepath ) && ($size = @filesize( $filepath )) )
        return getFileSize( $size );
} /* End of Function */

/**F
    @Name: isBlank@$
    @Type: boolean@$
    @Param: String $msg@$
    @Access: public@$
  
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ڿ ִ ȮѴ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function isBlank( $msg )
{
    return !ereg( '[^[:space:]]' , strip_tags( str_replace ( '&nbsp;' , '' , $msg ) ) );
} /* End of Function */

/**F
    @Name: isEmail@$
    @Type: boolean@$
    @Param: String $msg@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ڿ $msg Emailּ Ŀ ´ üũѴ.@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function isEmail( $msg )
{
    return eregi( '^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$' , $msg );
} /* End of Function */

/**F
    @Name: setNoCache@$
    @Type: boolean@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: Set HTTP Cache Control no-cache@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function setNoCache()
{
    if ( !headers_sent() )
    {
        header( 'Expires: Mon, 30 Jul 2001 01:23:00 GMT'                ); // Date in the past
        header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' ); // Set modified time
        header( 'Cache-Control: no-cache, must-revalidate'              ); // HTTP 1.1
        header( 'Pragma: no-cache'                                      ); // HTTP 1.0
        return true;
    }
    else return false;
} /* End of Function */

/**F
    @Name: getDirList@$
    @Type: Mixed(Array or boolean)@$
    @Param: String $dir@$
    @Access: public@$
    @Version: 1.0.2@$
    @Date: 03-09-14@$
    @Last Modified: 03-10-03@$
    @Detail: Get Directory List@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function getDirList( $dir = '' )
{
    $result = array();

    if ( $dir && is_dir( $dir ) && !is_link( $dir ) && $dirList = dir( $dir ) )
    {
        while ( $entry = $dirList->read() ) if ( ( $entry != '.' ) && ( $entry != '..' ) ) $result[] = $entry;
        return $result;
    }
    else return false;
} /* End of Function */

/**F
    @Name: rRmDir@$
    @Type: Boolean@$
    @Param: String $dir@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: Remove Directory all entry@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function rRmDir ( $dir )
{ 
    if ( $D = dir ( $dir ) )
    {
        while ( $entry = $D->read() )
        { 
            if ( $entry  != '.' && $entry != '..' )
            { 
                if ( is_Dir( $dir . '/' . $entry ) ) rRmDir( $dir . '/' . $entry ); 
                else @unLink ($dir . '/' . $entry ); 
            }
        }
    }
    else return false;
    $D->close(); 
    @rmDir ( $dir );
    return true;
} /* End of Function */

/**F
    @Name: RuruTime@$
    @Type: timestamp@$
    @Param: timestamp $TIME@$
    @Param: int $MODE@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ο  timestamp Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$

    RuruTime() Լ Ϲ time() Ǵ mktime() Լ ȯǴ ū timestamp  Ǵ ޸ ȿ ؼ timestamp  2000 1 1Ϸ 缳Ͽ   timestamp ȯϱ   Լ̴.

    @Example:
        1. Get new RuruTime() timestamp
        <code>print RuruTime();</code>

        2. UnixTimestamp to RuruTimestamp
        <code>
        $UnixTimeStamp = time();
        print RuruTime( $UnixTimeStamp , 1 );
        </code>

        3. RuruTimestamp to UnixTimestamp
        <code>
        $RuruTimeStamp = RuruTime();
        print RuruTime( $RuruTimeStamp );
        </code>
    @$
*/
function RuruTime( $TIME='none' , $MODE=0 )
{
    $M = 'mktime';
    $T = $M(0,0,0,1,1,2000);

    if ( $TIME == 'none' ) return ( $M() - $T ); // new ruru time
    else
    {
        if ( $MODE ) return ( $TIME - $T ); // unix time stamp to ruru time
        else return ( $TIME + $T ); // ruru time to unix time stamp
    }
} /* End of Function */

/**F
    @Name: autoLink@$
    @Type: String@$
    @Param: String $str@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: str ּҰ Ǵ κе ڵ ũǵ ȯִ Լ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function autoLink( $str )
{
    $str = eregi_replace( "<a href=(.*)http(.*)://([-a-z0-9=:_./~@?&#$%\(\)\200-\377]+)(.*)>(.*)</a>" , "[url 1=\\2 2=\\5 3=\\1\\3 \\4]" , $str );
    $str = eregi_replace( '(((f|ht){1}tp(s?)://)[-a-zA-Z0-9@:%_\+.~#?&//=]+)' , '<a href="\\1" target="_blank">\\1</a>' , $str );
    $str = eregi_replace( '([[:space:]()[{}])(www.[-a-zA-Z0-9@:%_\+.~#?&//=]+)' , '\\1<a href=" http://\\2" target="_blank">\\2</a>' , $str ); 
    $str = eregi_replace( '([_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3})' , '<a href="mailto:\\1">\\1</a>' , $str );
    $str = eregi_replace( "\[url 1=(.*) 2=(.*) 3=(.*) (.*)\]" , "<a href=http\\1://\\3\\4>\\2</a>" , $str );

    return $str;
} /* End of Function */

/**F
    @Name: phpHighlight@$
    @Type: String@$
    @Param: String $str@$
    @Access: public@$
    @See: Output Control Function(in PHP)@$
    @See: highlight_string()(in PHP)@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: PHPڵ尡 ִ ڿ Įڵ ȯŲ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function phpHighlight( $str )
{
    //ob_implicit_flush( false );
    ob_start();
    $str = ob_get_contents();

    highlight_string( $str );
    ob_end_clean();

    return $str;
} /* End of Function */

/**F
    @Name: unHtmlSpecialChars@$
    @Type: String@$
    @Param: Reference String $str@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: HTML Ư ױ׸  Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function unHtmlSpecialChars( &$str )
{
    $trans = get_html_translation_table( HTML_SPECIALCHARS );
    $trans = array_flip( $trans );
    return strtr( $str , $trans );
} /* End of Function */

/**F
    @Name: phpGet@$
    @Type: Array@$
    @Param: String $str@$
    @Access: public@$
    @See: unHtmlSpecialChars()@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: PHP code ִ ڿ PHP codeκ ColorCode ȯ 迭 HTMLκа PHP Code κ  ȯѴ@$

     ʿ..

    @Author: sunyruru<ruru@unfix.net>@$
*/
function phpGet( $str )
{
    static $byte_count = 0;
    $tmp = $str;
    $lt = '&lt;?';
    $gt = '?&gt;';

    do
    {
        if ( ( $start = strpos( $tmp , unHtmlSpecialChars( $lt ) ) ) === FALSE )
        {
            $noPHP[] = $tmp;
            $PHP[] = '';
            break;
        }

        $noPHP[] = substr( $tmp , 0 , $start );
        $tmp = substr( $tmp , $start );

        $end = strpos( $tmp , unHtmlSpecialChars( $gt ) ) + 2;
        $PHP[] = substr( $tmp , 0 , $end );
        $tmp = substr( $tmp , $end );

        if ( strpos ( $tmp , unHtmlSpecialChars( $gt ) ) === FALSE )
        {
            $noPHP[] = $tmp;
            $PHP[]   = ''  ;
            break;
        }
    } while ( true );

    $return[] = $noPHP;
    $return[] = $PHP;

    return $return;
} /* End of Function */

/**F
    @Name: refCheck@$
    @Type: boolean@$
    @Access: public@$
    @Version: 1.0.1@$
    @Date: 03-09-14@$
    @Last Modified: 03-10-05@$
    @Detail:     û  Ȯϴ Լ(Avoid Hack)@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function refCheck()
{
    return true;
    return ( !eregi( $GLOBALS["HTTP_HOST"] , $GLOBALS["HTTP_SERVER_VARS"]["HTTP_REFERER"] ) ) ? false : true;
} /* End of Function */

/**F
    @Name: oneByteOnly@$
    @Type: boolean@$
    @Param: String $str@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ڿ $str 1byte ڷθ ̷ִ üũѴ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function oneByteOnly( $str )
{
    if ( !is_string( $str ) ) return false;
    for ( $i = 0 , $cnt = strlen( $str ) ; $i < $cnt ; $i++ )
        if ( ord( $str[$i] ) > 128 ) return false;
    return true;
} /* End of Function */

/**F
    @Name: addSlash@$
    @Type: Mixed(String or boolean)@$
    @Param: Reference String $str@$
    @Access: public@$
    @See: stripSlash()@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: php.ini  magic_quotes_runtime flag off̸ slash ߰Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function addSlash( &$str )
{
  if ( !get_magic_quotes_runtime() ) return addSlashes( &$str );
  return false;
} /* End of Function */

/**F
    @Name: stripSlash@$
    @Type: Mixed(String or boolean)@$
    @Param: Reference String $str@$
    @Access: public@$
    @See: addSlash()@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: php.ini  magic_quotes_runtime flag off̸ slash Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function stripSlash( &$str )
{
    if ( !get_magic_quotes_runtime() ) return StripSlashes( &$str );
    return false;
} /* End of Function */

/**F
    @Name: getPerms@$
    @Type: int@$
    @Param: int(fileperms()) $mode@$
    @Access: public@$
    @See: fileperms()(in PHP)@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: fileperms() Լ   ۹̼ǰ  ˾ƺ  ۹̼ 3ڸ Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$
    @Example:
        echo getPerms( fileperms( __FILE__ ) );
        // result : 604
    @$
*/
function getPerms( $mode ) 
{
    $return = 0;
    if ( $mode & 00400 ) $return += 400;
    if ( $mode & 00200 ) $return += 200;
    if ( $mode & 00100 ) $return += 100;
    if ( $mode & 00040 ) $return += 40 ;
    if ( $mode & 00020 ) $return += 20 ;
    if ( $mode & 00010 ) $return += 10 ;
    if ( $mode & 00004 ) $return += 4  ;
    if ( $mode & 00002 ) $return += 2  ;
    if ( $mode & 00001 ) $return += 1  ;

    return $return;
} /* End of Function */

/**F
    @Name: juminCheck@$
    @Type: boolean@$
    @Param: String $jumin1@$
    @Param: String $jumin2@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ֹεϹȣ ´ ȮѴ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function juminCheck( $jumin1 , $jumin2 )
{
    $jumin = $jumin1.$jumin2;

    if ( !ereg( "^[[:digit:]]{6}[1-4][[:digit:]]{6}$" , $jumin ) ) return false;

    $Y = ( $jumin[6] < "3" ) ? "19" : "20";
    $Y .= substr( $jumin , 0 , 2 );
    $M = substr( $jumin , 2 , 2 );
    $D = substr( $jumin , 4 , 2 );
    if ( !checkdate( $M , $D , $Y ) ) return false;

    $check = array( 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 2 , 3 , 4 , 5 );
    for ( $i = $sum = 0 ; $i < 12 ; $i++ ) $sum += ( $jumin[$i] * $check[$i] );
    if ( ( 11 - ( $sum % 11 ) ) % 10 != $jumin[12] ) return false;
    return true;
} /* End of Function */

/**F
    @Name: fileData@$
    @Type: Mixed(String or boolean)@$
    @Param: String $file@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: Filepath   о鿩 ڿ ȯѴ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function fileData( $filepath )
{
    if ( is_file( $filepath ) )
    {
        $f = fopen( $filepath , 'r' );
        $str = fread( $f , filesize( $filepath ) );
        fclose( $f );

        return $str;
    }
    else return false;
} /* End of Function */

/**F
    @Name: allowMethod@$
    @Type: boolean@$
    @Param: String $type(POST or GET .. : Default - 'POST')@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-14@$
    @Last Modified: 03-09-14@$
    @Detail: ٰ HTTP ޼ҵ带 Ѵ@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function allowMethod( $type = 'POST' )
{
    return (trim(strtolower($GLOBALS["HTTP_SERVER_VARS"]["REQUEST_METHOD"])) == trim(strtolower($type)));
} /* End of Function */

/**
* ڿ html Ưڵ Ư ױ׷ ȯŰ ū ǥ ǥ ױ׷ ȯѴ
*
*  Լ html  title ɼǿ ֱ 
*  κ ɿ ϸ  ̴
*
* @return	string
* @param	string      $str
* @access	public
* @since    2003-12-19
* @author	sunyruru<ruru@unfix.net>
* @see
*/
function getQuotPlain( $str )
{
    return str_replace( '"' , "&quot;" , htmlspecialchars( $str ) );
} /* End of Function */


/* GET */
function gV( $var ){ return $GLOBALS[$var]; }
function gG( $var ){ return $GLOBALS["HTTP_GET_VARS"][$var]; }
function gP( $var ){ return $GLOBALS["HTTP_POST_VARS"][$var]; }
function gC( $var ){ return $GLOBALS["HTTP_COOKIE_VARS"][$var]; }
function gS( $var )
{
    global $HTTP_COOKIE_VARS, $HTTP_SESSION_VARS;
    return $HTTP_SESSION_VARS[$var];
}

/* SET */
function sV( $var , &$value ){ $GLOBALS[$var] = $value; }
function sG( $var , &$value ){ $GLOBALS["HTTP_GET_VARS"][$var] = $value; }
function sP( $var , &$value ){ $GLOBALS["HTTP_POST_VARS"][$var] = $value; }
function sC( $var , &$value ){ $GLOBALS["HTTP_COOKIE_VARS"][$var] = $value; }
function sS( $var , &$value )
{
    global $HTTP_COOKIE_VARS, $HTTP_SESSION_VARS;
    $GLOBALS["HTTP_SESSION_VARS"][$var] = $value;
}
/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>