<?php
// +----------------------------------------------------------------------+
// | PHP version 4.3.2                                                    |
// +----------------------------------------------------------------------+
// | Authors: Sunyruru(SunWoo Kim) <sunyruru@hotmail.com, ruru@unfix.net> |
// +----------------------------------------------------------------------+
//
// $Id: rcom.lib.php,v 1.1.1.1 2004/04/07 00:43:51 sunyruru Exp $
// @Detail :   rCommunity   ʿ Լ Ƶ function library Դϴ. @$
// @Last Modified : 03-08-13 @$


/**F
    @Name: cook@$
    @Type: String@$
    @Param: String $key@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Get Cookie value@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function cook( $key )
{
    return $GLOBALS["HTTP_COOKIE_VARS"][RC_TBL.$key];
}

/**F
    @Name: sess@$
    @Type: String@$
    @Param: String $key@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Get Session value@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function sess( $key )
{
    return $GLOBALS["HTTP_SESSION_VARS"][RC_TBL.$key];
}

/**F
    @Name: getName@$
    @Type: String@$
    @Param: String $str@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Get Name@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function getName( $str )
{
    return RC_TBL.'_'.$str;
}

/**
* Get Level
*
* @return	int     Level
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-09-18
*/
function getLevel()
{
    if ( isMember() ) return $GLOBALS["_USR"]["level"];
    else return 10;
}

/**
* Get Level2
*
* @return	int     Level2
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-09-18
*/
function getLevel2()
{
    if ( isMember() ) return $GLOBALS["_USR"]["level2"];
    else return 3;
}

/**F
    @Name: getTotalPoint@$
    @Type: int@$
    @Param: int $point1 Write Article@$
    @Param: int $point2 Write Comment@$
    @Param: int $point3 Special Point@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-10-12@$
    @Last Modified: 03-10-12@$
    @Detail: Get Total point@$
    @Since: RuruCommunity 1.0.157-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function getTotalPoint( $point1 , $point2 , $point3 )
{
    return ($point1*10)+$point2+$point3;
} /* End of Function */

/**
* Check member 'Is Member?'
*
* @return	bool
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-09-18
*/
function isMember()
{
    global $HTTP_COOKIE_VARS;
    static $isMember = false;

    if ( $isMember ) return true;

    if (cook('_login_id')&&cook('_login_pass')&&is_numeric(cook('_site'))) return ($isMember = true);
    else return false;
} /* End of Function */

/**F
    @Name: isAdmin@$
    @Type: boolean@$
    @See: isMember()@$
    @See: isBAdmin()@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Check admin@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function isAdmin()
{
    static $isAdmin = false;
    if ( $isAdmin ) return true;
    if ( isMember() && ( getLevel() < 4 || isBAdmin() || isGAdmin() || isSAdmin() ) ) return true;
    else return false;
}

/**F
    @Name: isBAdmin@$
    @Type: boolean@$
    @See: cook()@$
    @Access: public@$
    @Version: 1.0.1@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Check Board admin@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function isBAdmin()
{
    static $isBAdmin = false;
    if ( $isBAdmin ) return true;
    if ( @in_array( $id , @explode( "|" , @$GLOBALS[_PAGE][badmin] ) ) ) return true;
    else return false;
}

function isGAdmin()
{
    static $isGAdmin = false;
    if ( $isGAdmin ) return true;
    if ( @in_array( $id , @explode( "|" , @$GLOBALS[_GRP][gadmin] ) ) ) return true;
    else return false;
}

function isSAdmin()
{
    static $isSAdmin = false;
    if ( $isSAdmin ) return true;
    if ( @in_array( $id , @explode( "|" , @$GLOBALS[_SITE][sadmin] ) ) ) return true;
    else return false;
}

/**F
    @Name: copyright@$
    @Type: boolean@$
    @See: Global SKIN variable@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-09-18@$
    @Last Modified: 03-09-18@$
    @Detail: Print output copyright message@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function copyright()
{
    include_once RC_ROOT."/copy.txt";
    include_once $GLOBALS[SKIN]."/copy.txt";
}

/**F
    @Name: importValue@$
    @Type: boolean@$
    @Param: String $method@$
    @Param: String $var[, $var[...]]@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-10-03@$
    @Last Modified: 03-10-03@$
    @Detail: ʿ   ȿ ҷδ@$
    @Since: 1.0.73-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function importValue( $method )
{
    $argc = func_num_args();
    $argv = func_get_args();

    $method = strtoupper( $method );

    if ( $argc < 2 || $method != "POST" || $method != "GET" ||
        $method != "SERVER" || $method != "COOKIE" || $method != "SESSION" )
        return false;

    for ( $i = 0 , $cnt = $argc+1 ; $i < $cnt ; $i++ )
    {
        $idx = $i+2;
        $GLOBALS[$argv[$idx]] =& $GLOBALS["HTTP_".$method."_VARS"][$argv[$idx]];
    } /* End of For */
    return true;
} /* End of Function */

/**F
    @Name: ini@$
    @Type: mixed@$
    @Param: String $section@$
    @Param: String $var@$
    @Param: String $file@$
    @Param: String $default@$
    @Access: public@$
    @See: RuruINI::value()@$
    @Version: 1.0.0@$
    @Date: 03-10-04@$
    @Last Modified: 03-10-04@$
    @Detail: Use RuruINI::value()@$
    @Since: 3.0.114-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function ini( $section , $var , $file = "" , $default = "" )
{
    global $INI;

    if ( !$file )
        $file = $INI->INIfile;

    return $INI->value( $section , $var , $file , $default );
} /* End of Function */

/**F
    @Name: getModuleDir@$
    @Type: String@$
    @Param: String $module@$
    @Access: public@$
    @Version: 1.0.0@$
    @Date: 03-10-27@$
    @Last Modified: 03-10-27@$
    @Detail: Get Module's Directory@$
    @Since: rcom 1.0.182-dev@$
    @Author: sunyruru<ruru@unfix.net>@$
*/
function getModuleDir( $module )
{
    return RC_MODULE."/$module";
} /* End of Function */

/**
* ڵ α 
*
* @return	bool
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-12-22
*/
function autoLogin() // ʿ -_-;;;
{
    global $HTTP_COOKIE_VARS;
    if ( headers_sent() ) return false;

    if ( cook("_auto_login") && !(cook("_login_id") && cook("_login_pass") && cook("_site")) )
    {
        $tmp = explode( "|" , trim( cook("_auto_login") ) );
        return loginProcess( $tmp[0] , $tmp[1] , $tmp[2] );
    }
    return false;
} /* End of Function */

/**
* α 
*
* @return	bool
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-12-22
*/
function loginProcess( $site , $id , $password , $autologin = 0 , $lifetime = 86400)
{
    global $HTTP_COOKIE_VARS;

    if ( headers_sent() ) return false;

    if ( is_numeric( $site ) && $id && $password )
    {
        @setcookie( RC_TBL."_site" , $site , time() + $lifetime );
        @setcookie( RC_TBL."_login_id" , $id , time() + $lifetime );
        @setcookie( RC_TBL."_login_pass" , $password , time() + $lifetime );
        if ( $autologin ) @setcookie( RC_TBL."_auto_login" , "$site|$id|$password" , time() + $lifetime );

        return true;
    }

    return false;
} /* End of Function */

/**
* α׾ƿ 
*
* @return	bool
* @access	public
* @author	sunyruru<ruru@unfix.net>
* @since    03-12-22
*/
function logoutProcess()
{
    global $HTTP_COOKIE_VARS;

    if ( headers_sent() ) return false;

    @setcookie( RC_TBL."_site" , "" );
    @setcookie( RC_TBL."_login_id" , "" );
    @setcookie( RC_TBL."_login_pass" , "" );
    @setcookie( RC_TBL."_auto_login" , "" );

    return true;
} /* End of Function */

/*
 * Local Variables:
 * mode: php
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
?>