CREATE TABLE rc_board (
  no int unsigned NOT NULL auto_increment,
  pri_key int NOT NULL default '0',
  sec_key tinyint unsigned NOT NULL default '0',
  depth tinyint unsigned default '0',
  cate int default '0',
  next int default '0',
  prev int default '0',
  name varchar(255) binary default '',
  email varchar(255) default '',
  homepage varchar(255) default '',
  subject varchar(255) binary default '',
  regdate int unsigned default '',
  ip int default '',
  password char(16) default '',
  use_html tinyint default '0',
  reply_mail enum('0','1') default '0',
  secure enum('0','1') default '0',
  count int unsigned default '0',
  vote int default '0',
  comment int unsigned default '0',
  memo text,
  up text,
  link text,
  is_member varchar(255),
  is_notice tinyint,
  PRIMARY KEY (no),
  index no (pri_key,sec_key)
) TYPE=MyISAM;

CREATE TABLE rc_admin (
  no int unsigned NOT NULL auto_increment,
  site int(11) unsigned default '1' not null,
  grp int unsigned NOT NULL default '',
  code varchar(20) NOT NULL default '',
  skin varchar(30) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  board_width varchar(255) NOT NULL default '95%',
  new_art int unsigned default '86400',
  cut_sub int unsigned default '0',
  page_num tinyint unsigned default '10',
  index_num tinyint unsigned default '10',
  head_script text,
  head_file varchar(255) default '',
  head_tag text,
  tail_tag text,
  tail_file varchar(255) default '',
  html tinyint default '0',
  listing enum('0','1') NOT NULL default '1',
  reply enum('0','1') NOT NULL default '1',
  emoticon enum('0','1') NOT NULL default '1',
  formmail enum('0','1') NOT NULL default '1',
  category enum('0','1') NOT NULL default '1',
  comment enum('0','1') NOT NULL default '1',
  search enum('0','1') NOT NULL default '1',
  show_mail enum('0','1') NOT NULL default '1',
  show_ip enum('0','1') NOT NULL default '1',
  use_whois enum('0','1') NOT NULL default '1',
  use_filter enum('0','1') NOT NULL default '1',
  ext_mode tinyint NOT NULL default '0',
  up tinyint NOT NULL default '1',
  upsize int unsigned default '0',
  link tinyint NOT NULL default '1',
  total_data int unsigned NOT NULL default '0',
  body_option tinytext,
  filter text,
  tag text,
  ext text,
  badmin text,
  perm_read tinyint unsigned NOT NULL default '0',
  perm_write tinyint unsigned NOT NULL default '0',
  perm_modify tinyint unsigned NOT NULL default '0',
  perm_reply tinyint unsigned NOT NULL default '0',
  perm_list tinyint unsigned NOT NULL default '0',
  perm_del tinyint unsigned NOT NULL default '0',
  perm_comment tinyint unsigned NOT NULL default '0',
  perm_notice tinyint unsigned NOT NULL default '0',
  perm_secret tinyint unsigned NOT NULL default '0',
  perm_html tinyint unsigned NOT NULL default '0',
  regdate int default '0',
  PRIMARY KEY (no),
  KEY code (site, grp, code)
) TYPE=MyISAM;

CREATE TABLE rc_category (
  no int unsigned NOT NULL auto_increment,
  sub int unsigned default '100000000' NOT NULL,
  dep tinyint unsigned default '1' NOT NULL,
  parent int unsigned default '100000000' NOT NULL,
  mode tinyint unsigned default '1' NOT NULL, # 1 board , 2 group , 3 site
  site int unsigned default '1', # NOT NULL
  grp int unsigned default '1', # If null site
  code varchar(20) default '', # if null group
  name varchar(255) binary NOT NULL default '',
  data int unsigned NOT NULL default '', # data count
  PRIMARY KEY (no),
  KEY sub (site,grp,code,sub)
) TYPE=MyISAM;

CREATE TABLE rc_comment (
  no int unsigned NOT NULL auto_increment,
  grp int unsigned NOT NULL default '',
  code varchar(20) default '',
  pid int unsigned default '',
  name varchar(255) binary default '',
  pass char(16) default '',
  comment text,
  regdate int unsigned default '',
  ip int default '',
  PRIMARY KEY (no),
  KEY no (code,pid)
) TYPE=MyISAM;

CREATE TABLE rc_group (
  no int unsigned NOT NULL auto_increment,
  site int unsigned default '1' not null,
  grp_name varchar(255) binary default '',
  pub tinyint unsigned default '0',
  join_skin varchar(255) default '',
  mail_skin varchar(255) default '',
  head_file varchar(255) default '',
  head_tag text,
  tail_tag text,
  tail_file varchar(255) default '',
  bad_ip text,
  join_level tinyint default '9',
  limit_age tinyint default '14',
  after_url varchar(255),
  return_pass enum('0','1') default '1',
  get_jumin enum('0','1') default '1',
  get_job enum('0','1') default '1',
  get_hobby enum('0','1') default '1',
  get_addr enum('0','1') default '1',
  get_phone enum('0','1') default '1',
  get_handphone enum('0','1') default '1',
  get_ofc_addr enum('0','1') default '1',
  get_ofc_phone enum('0','1') default '1',
  get_home enum('0','1') default '1',
  get_icq enum('0','1') default '1',
  get_msn enum('0','1') default '1',
  get_picture enum('0','1') default '1',
  get_mailing enum('0','1') default '1',
  get_public enum('0','1') default '1',
  regdate int default '0',  
  PRIMARY KEY (id)
) TYPE=MyISAM;

CREATE TABLE rc_member (
  no int unsigned NOT NULL auto_increment,
  site int default '0',
  grp varchar(255) default '',
  id varchar(255) NOT NULL,
  pass char(32) NOT NULL,
  birth int unsigned DEFAULT '0',
  jumin char(32) DEFAULT '',
  level tinyint DEFAULT '10',
  level2 tinyint DEFAULT '3',
  name varchar(255) binary DEFAULT '',
  nick varchar(255) binary DEFAULT '',
  job varchar(255) binary DEFAULT '',
  hobby varchar(255) binary DEFAULT '',
  addr varchar(255),
  phone varchar(255),
  cellular_phone varchar(255),
  ofc_addr varchar(255),
  ofc_phone varchar(255),
  home varchar(255),
  email varchar(255),
  icq int unsigned default '0',
  msn varchar(255),
  picture varchar(255),
  mailing enum('0','1') default '1',
  profile text,
  public enum('0','1') default '1',
  badmin text,
  point1 int unsigned default '0',
  point2 int unsigned default '0',
  point3 int unsigned default '0',
  regdate int default '0',
  etc_flag text,
  PRIMARY KEY (no),
  KEY site (site)
) TYPE=MyISAM;

CREATE TABLE rc_message (
  no int unsigned NOT NULL auto_increment,
  get int unsigned NOT NULL default '0',
  send int unsigned NOT NULL default '0',
  readed enum('0','1') default '0',
  regdate int,
  memo text,
  PRIMARY KEY (no)
) TYPE=MyISAM;

CREATE TABLE rc_site (
  no int(10) unsigned NOT NULL auto_increment,
  member_cnt int(11) unsigned default '0',
  group_cnt int(11) unsigned default '0',
  site_name varchar(255) binary default NULL,
  pub tinyint(3) unsigned default '1',
  join_skin varchar(255) default 'ruru_basic',
  info_skin varchar(255) default 'ruru_basic',
  mail_skin varchar(255) default 'ruru_basic',
  head_file varchar(255) default '',
  head_tag text,
  tail_tag text,
  tail_file varchar(255) default '',
  bad_ip text,
  join_level tinyint(4) default '9',
  limit_age tinyint(4) default '14',
  after_url varchar(255) default '',
  return_pass enum('0','1') default '1',
  get_jumin enum('0','1') default '1',
  get_job enum('0','1') default '1',
  get_hobby enum('0','1') default '1',
  get_addr enum('0','1') default '1',
  get_phone enum('0','1') default '1',
  get_handphone enum('0','1') default '1',
  get_ofc_addr enum('0','1') default '1',
  get_ofc_phone enum('0','1') default '1',
  get_home enum('0','1') default '1',
  get_icq enum('0','1') default '1',
  get_msn enum('0','1') default '1',
  get_picture enum('0','1') default '1',
  get_mailing enum('0','1') default '1',
  get_public enum('0','1') default '1',
  join_etc_flag text,
  regdate int default '0',  
  PRIMARY KEY (no)
) TYPE=MyISAM;
